<?php
/************************************************************************/
/* Minimus Blog: Web Portal System                                      */
/* ===============================                                      */
/* Write by Cyril Levert                                                */
/* Copyright (c) 2009-2010                                              */
/* http://www.php-minimus.org                                           */
/* dev@php-minimus.org                                                  */
/*                                                                      */
/* This program is free software.                                       */
/************************************************************************/
/* Based on PHP-Maximus: Web Portal System                              */
/************************************************************************/
defined('MINIMUS') or die ('Access denied langues MINIMUS directly...');

$tmp = INCLUDE_PATH.'kernel/perso/langues.php';
if ( is_file( $tmp ) ) include_once( $tmp );

isset( $lang  ) ? $currentlang = secure( $lang , 'lang') : $currentlang = 'french';
if ((isset($newlang)) AND !stristr($newlang,'\.')) {
	$newlang = secure( $newlang, 'lang');
	if ( ! preg_match( '`(english|french|italian|spanish|japanese)`', $newlang ) ) $newlang = 'french';
	$tmp = INCLUDE_PATH.'language/lang-'.$newlang.'.php';
	if (is_file( $tmp )) {
		@setcookie('lang',$newlang, MAX_TIME + 31536000);
		include_once( $tmp );
		$currentlang = $newlang;
		define('CURRENTLANG', $newlang);
	}
} else {
	$currentlang = secure( $language, 'lang');
	if ( ! preg_match( '`(english|french|italian|spanish|japanese)`', $currentlang ) ) $currentlang = 'french';
	@setcookie('lang',$currentlang, MAX_TIME + 31536000);
	$tmp = INCLUDE_PATH.'language/lang-'.$currentlang.'.php';
	if ( is_file( $tmp ) ) include_once( $tmp );
	define('CURRENTLANG', $currentlang);
}


if( ! function_exists('Get_Lang') ) {
	function get_lang( $module ) {
		global $currentlang, $language;
		$module      = secure( $module, '', 'clean', 'xss');
		$currentlang = secure( $currentlang, 'lang');
		$tmp = INCLUDE_PATH.'modules/'.$module.'/language/lang-'.$currentlang.'.php';
		if ( is_file( $tmp ) ) include_once( $tmp );
	}
}