<?php
/************************************************************************/
/* Minimus Blog: Web Portal System                                      */
/* ===============================                                      */
/* Write by Cyril Levert                                                */
/* Copyright (c) 2009-2010                                              */
/* http://www.php-minimus.org                                           */
/* dev@php-minimus.org                                                  */
/*                                                                      */
/* This program is free software.                                       */
/************************************************************************/
/* Based on PHP-Maximus: Web Portal System                              */
/************************************************************************/
defined('MINIMUS') OR die ('Access denied mainfile.php MINIMUS directly...');

define('Serverload_Status', false );
define('UserLastSeen_Status', false );
define('UserLastVisit_Status', false );
define('Funct_ob_end_flush', true );
define('Chmods_Importation', 0 ); // 0 or 0644 or 0744 or 0754 or 0755 or 0774 or or 0775 or 0777
define('CodeAccessible_Status', true );

define('DIE_INCLUDE', 'Dsol, un incident majeur empche d\'accder  ce site: Code: ');

list($usec, $sec) = explode(' ', microtime());
$start_time = ((float)$usec + (float)$sec);

( !empty( $op ) ) ? $op = strip_tags( $op ) : $op = '';
( !empty( $file ) ) ? $file = strip_tags( $file ) : $file = 'index';

$GOOGLETAPSG_ARRAY = array();

//@ini_set( 'allow_url_fopen', 0 );
//@ini_set( 'variables_order', 0 );
//@ini_set( 'register_argc_argv', 0 );
//@ini_set( 'expose_php', 0 );
//@ini_set( 'default_socket_timeout', 0 );
define('REGISTER_GLOBALS', @ini_get('register_globals'));
define('MAGIC_QUOTES_GPC', @get_magic_quotes_gpc());
define('NUKE_FILE', true);
define('MAX_TIME', @time() );
define('PHP_SELF', strip_tags( $_SERVER['PHP_SELF'] ) );

FUNCTION define_once( $constant, $value ) {
	if ( !defined( $constant ) ) {
        	define( $constant, $value );
    	}
}

if(!defined('END_TRANSACTION')) define('END_TRANSACTION', 2);
if (!REGISTER_GLOBALS) @import_request_variables('GPC', '');

$_SERVER['HTTP_USER_AGENT'] = htmlentities(strip_tags($_SERVER['HTTP_USER_AGENT']));
if (strstr($_SERVER['HTTP_USER_AGENT'], 'compatible') || strstr($_SERVER['HTTP_USER_AGENT'], 'Gecko')) {
	if (@extension_loaded('zlib')) { if(!@ob_start('ob_gzhandler')) @ob_start(); }
} else {
	if (strstr( htmlentities( $HTTP_SERVER_VARS['HTTP_ACCEPT_ENCODING']) , 'gzip')) {
		if (@extension_loaded('zlib')) {
      			$do_gzip_compress = true;
      			@ob_start(array('ob_gzhandler',5));
			@ob_implicit_flush(0);
			@Header('Content-Encoding:gzip');
			if (ereg('MSIE', $_SERVER['HTTP_USER_AGENT']))
					header('Content-Encoding:gzip');
		}
	}
}

if ( ! empty( $_COOKIE['mod_debug'] ) ) {
	define('MAXIMUS_DEBUG', true );
} else {
	define('MAXIMUS_DEBUG', false );
}

function benchmark ($nom_etape){
	global $etape_prec;
	$temps_ecoule = ($etape_prec) ? round(($GLOBALS['db']->timing() - $etape_prec)*1000, 2) : 0;
	$etape_prec = $GLOBALS['db']->timing();
	return $temps_ecoule. 'ms';
}

function maxdebug($query, $error, $duration, $type=false, $file='') {
    	global $wb_query;
	if ( !empty( $error ) ) {
		@ isset( $wb_query['count_error'] ) ? $wb_query['count_error']++ : $wb_query['count_error'] = 1;
	} else {
		$wb_query['count_error'] = '';
	}
    	static $start_time;
        $mtime = microtime();
        $mtime = explode(' ',$mtime);
        $mtime = $mtime[1] + $mtime[0];
        if (!isset($start_time)) {
            $start_time = $mtime;
            $time = 0;
        } else {
           $time = $mtime - $start_time;
        }
        $wb_query['time'][]    = round($time, 5);
        $wb_query['sqltime'][] = benchmark ($duration);
        $wb_query['query'][]   = $query;
        $wb_query['error'][]   = $error;
        $wb_query['type'][]    = $type;
}

/** include all classes */
$tmp = INCLUDE_PATH.'kernel/class';
if ( is_dir( $tmp ) ) {
	$casedir = dir( $tmp );
	while( $func = $casedir->read() ) {
		if( substr($func, 0, 6) == 'class.' ) {
			$tmp = INCLUDE_PATH.'kernel/class/'.$func ;
			if ( is_file( $tmp ) ) include_once( $tmp );
		}
	}
	@closedir( $casedir->handle );
}

$tmp = INCLUDE_PATH.'kernel/security.php';
( is_file( $tmp ) ) ? include_once( $tmp ) : die( DIE_INCLUDE.' '.__LINE__ );

isset( $admin ) ? $admin = secure( $_COOKIE['admin'], '', '', 'xss') : $admin = '';
isset( $user ) ? $user = secure( $_COOKIE['user'], '', '', 'xss') : $user = '';
isset( $pagetitle ) ? $pagetitle = secure( $pagetitle, '', '', 'xss') : $pagetitle = '';
isset( $anonymous ) ? $anonymous = secure( $anonymous, '', '', 'xss') : $anonymous = 'Anonymous';
isset( $main_module ) ? $main_module = secure( $main_module, '', '', 'xss') : $main_module = 'MyAccount';
isset( $multilingual ) ? $multilingual = secure( $multilingual, '', 'xss') : $multilingual = '1';
isset( $currentlang  ) ? $currentlang = secure( $currentlang , '', 'xss') : $currentlang = 'french';
isset( $querylang  ) ? $querylang = secure( $querylang , '', '', 'xss') : $querylang = '';
isset( $_SERVER['HTTP_USER_AGENT'] ) ? $_SERVER['HTTP_USER_AGENT'] = secure( $_SERVER['HTTP_USER_AGENT'] , '', '', 'xss') : $_SERVER['HTTP_USER_AGENT'] = '';
isset( $_SERVER['HTTP_X_FORWARDED_FOR'] ) ? $_SERVER['HTTP_X_FORWARDED_FOR'] = secure( $_SERVER['HTTP_X_FORWARDED_FOR'] , '', '', 'xss') : $_SERVER['HTTP_X_FORWARDED_FOR'] = '';
isset($_SERVER['REMOTE_ADDR'] ) ? $_SERVER['REMOTE_ADDR'] = secure( $_SERVER['REMOTE_ADDR'] , '', '', 'xss') : $_SERVER['REMOTE_ADDR'] = '';

$tmp = INCLUDE_PATH.'kernel/config.php';
( is_file( $tmp ) ) ? include_once( $tmp ) : die( DIE_INCLUDE.' '.__LINE__ );

@session_save_path( ROOT_PATH.'/'.CACHE.'/'.SESSIONS_PATH.'/' );
@session_cache_expire('30');
@session_start();
$ip = !empty( $_SERVER['HTTP_X_FORWARDED_FOR'] ) ? $_SERVER['HTTP_X_FORWARDED_FOR'] : $_SERVER['REMOTE_ADDR'];
define('SECU_SESSION', $ip.''.$sitekey.''.$_SERVER['HTTP_USER_AGENT']);
if( empty( $_SESSION ) ) {
	$_SESSION['secu'] = SECU_SESSION;
} elseif( $_SESSION['secu'] !== SECU_SESSION ) {
	@session_regenerate_id();
	$_SESSION = array();
}

if (!defined('CONFIG_IS_LOADED')) {
    if ( !defined('DBNAME') ) {
		if (is_file(INCLUDE_PATH.'install/index.php')) {
			Header('Location: install/index.php'); die();
		} else {
			die( DIE_INCLUDE.' '.__LINE__ );
		}
	}
} else {
	if ( !defined('DBNAME') ) die( DIE_INCLUDE.' '.__LINE__ );
}

if ( defined('DBNAME') && defined('CONFIGPHP') && is_file(INCLUDE_PATH.'install/index.php') )
	include_once(INCLUDE_PATH.'kernel/fly/error_db.php');

define('URLE', secure( $_SERVER['REQUEST_URI'], 'strip', 'hard' ) );
define('MAX_URL', URLE );

( @ empty( $_SESSION['mod_debug_errors'] ) ) ? define('MAXIMUS_DISPLAY_ERROR', false ) : define('MAXIMUS_DISPLAY_ERROR', true );

/** Error reporting, to be set in config.php */
if( ( MAXIMUS_DISPLAY_ERROR === true && DISPLAY_ERRORS === true) or ( FORCE_DISPLAY_ERRORS === TRUE ) ) {
	@ini_set('display_errors', 1);
	@ini_set('html_errors', 1);
	( FORCE_MODE_DEVELOPPER === true ) ? @error_reporting(E_ALL) : @error_reporting(E_ALL^E_NOTICE);
} else {
	@ini_set('display_errors', 0);
	@ini_set('html_errors', 0);
	@error_reporting(0);
}

$tmp = INCLUDE_PATH.'kernel/layer/'.DBTYPE.'.php';
( is_file( $tmp ) ) ? include_once( $tmp ) : die( DIE_INCLUDE.' '.__LINE__ );

$db = new sql_db( DBHOST, DBUNAME, DBPASS, DBNAME, false);
if( empty( $db->db_connect_id ) ) include_once(INCLUDE_PATH.'kernel/fly/error_db.php');

$tmp = INCLUDE_PATH.'kernel/constants.php';
( is_file( $tmp ) ) ? include_once( $tmp ) : die( DIE_INCLUDE.' '.__LINE__ );

FUNCTION Minimus_get_config( $ok = false ){
	$tmp = INCLUDE_PATH.''.CACHE.'/Configuration/'.PREFIX_CACHE.'_cache_config_website.php';
	if ( is_file( $tmp ) ) {
		include_once( $tmp );
		return $config;
	} else {
		$sql = 'SELECT `config_name`, `config_value` FROM `'.TABLE_CONFIG.'` ';
		foreach( $GLOBALS['db']->get_list_object( $sql ) as $row ) {
			$row->config_name  = secure( $row->config_name, 'strip', 'clean');
			$row->config_value = secure( $row->config_value, 'strip', 'clean');
			$config[$row->config_name] = $row->config_value;
		}
		if ( !empty( $ok ) )
			cache_sql( 'config_website', 'config', $config );
		return $config;
	}
}
$config        = Minimus_get_config();
$sitename      = $config['sitename'];
$slogan        = $config['slogan'];
$urlsite       = $config['urlsite'];
$adminmail     = $config['adminmail'];
$Default_Theme = $config['Default_Theme'];
$anonymous     = $config['anonymous'];
$rewrite       = $config['rewrite'];
$main_module   = $config['main_module'];
$language      = $config['language'];

define('URL_SITE', $urlsite );
$nukeurl = $urlsite;

$tmp = INCLUDE_PATH.'kernel/users.php';
( is_file( $tmp ) ) ? include_once( $tmp ) : die( DIE_INCLUDE.' '.__LINE__ );

$tmp = INCLUDE_PATH.'kernel/firewall.php';
( is_file( $tmp ) ) ? include_once( $tmp ) : die( DIE_INCLUDE.' '.__LINE__ );

if ( is_file(INCLUDE_PATH.'class1.php') && ! is_file(INCLUDE_PATH.'kernel/class1.php') ) {
	include_once(INCLUDE_PATH.'class1.php');
} elseif (is_file(INCLUDE_PATH.'kernel/class1.php')) {
	include_once(INCLUDE_PATH.'kernel/class1.php');
} else {
	die( DIE_INCLUDE.' '.__LINE__ );
}

$tmp = INCLUDE_PATH.'kernel/utility.php';
if ( is_file( $tmp ) ) include_once( $tmp );

$ThemeSel = $Default_Theme;
define('MAXIMUS_THEME', true);

$tmp = INCLUDE_PATH.'kernel/langues.php';
if ( is_file( $tmp ) ) include_once( $tmp );

$lang_dir = '';
if (!isset($ThemeSel)) $ThemeSel = 'ordinaire';

$tmp = INCLUDE_PATH.'kernel/version.php';
if ( is_file( $tmp ) ) include_once( $tmp );

if (isset($gfx)){
	switch($gfx) {
		case 'gfx':
			$datekey = date('F j');
			$_SERVER['HTTP_USER_AGENT'] = htmlentities(strip_tags($_SERVER['HTTP_USER_AGENT']));
			$rcode = hexdec(md5($_SERVER['HTTP_USER_AGENT'].$sitekey.$random_num.$datekey));
			$code  = substr($rcode, 2, 6);
			if (extension_loaded('gd')) {
				$image      = @ImageCreateFromJPEG('images/code_bg.jpg');
				$text_color = @ImageColorAllocate($image, 0, 0, 0);
				@Header('Content-type:image/jpeg');
				@ImageString ($image, 5, 12, 2, $code, $text_color);
				@ImageJPEG($image, '', 75);
				@ImageDestroy($image);
				die();
			} else {
				echo '<strong>'.$code.'</strong>';
				die();
			}
		break;
	}
}

if (isset($gfx2)){
	switch($gfx2) {
		case 'gfx2':
			if ( ! stristr( strip_tags( $_SERVER['HTTP_REFERER'] ), strip_tags( $_SERVER['SERVER_NAME'] ) ) ) die();
			$random_num = $maxran = '';
			mt_srand ((double)microtime()*1000000);
			$maxran     = 1000000;
			$random_num = mt_rand(0, $maxran);
			$_SESSION['securecode'] = $random_num;
			$datekey  = @date('L F j');
			$_SERVER['HTTP_USER_AGENT'] = htmlentities( check_html( $_SERVER['HTTP_USER_AGENT'], 'nohtml' ) );
			$rcode    = @md5($_SERVER['HTTP_USER_AGENT'] . $sitekey . $random_num . $datekey);
			$code     = substr($rcode, 2, 6);
			if (extension_loaded('gd')) {
				$image      = @ImageCreateFromJPEG('images/code_bg.jpg');
				$text_color = @ImageColorAllocate($image, 0, 0, 0);
				@Header('Content-type:image/jpeg');
				@ImageString ($image, 5, 12, 2, $code, $text_color);
				@ImageJPEG($image, '', 75);
				@ImageDestroy($image);
				die();
			} else {
				echo '<strong>'.$code.'</strong>';
				die();
			}
		break;
	}
}
//if( ! function_exists('Query_Die') ) {
	Function Query_Die($msg_code, $msg_text = '', $msg_title = '', $err_line = '', $err_file = '', $sql = ''){
 		global $adminmail, $sitename, $cookie, $currentlang, $anonymous;
		( ! empty( $currentlang ) )  ? $lang = secure( $currentlang, 'lang') : $lang = '';
		$tmp = INCLUDE_PATH.'language/lang-'.$lang.'.php';
		if ( is_file( $tmp ) ) include_once( $tmp );
		$sql_error = $GLOBALS['db']->sql_error();
		$debug_text = '';
		if ( ! empty( $sql_error['message'] ) )	{
			$debug_text .= DEBUG_SQLERROR.' '.$sql_error['code'].'<br/> --> '.$sql_error['message'].'<br/>'."\n";
		}
		if ( ! empty( $sql ) ) $debug_text .= ' - '.$sql;
		echo '<div align="center">'._MESSAGE_ERROR1.'<br /></div><br />'._MESSAGE_ERROR2.'<br />';
		$subject = DEBUG_TITLE_MAIL." $sitename";
		$msg = "$sitename\n\n";
		$msg .= "$msg_code\n"
   		 ."".DEBUG_MESSAGE." $msg_text\n";
   		 //."Line: $err_line\n"
		if ( !empty( $err_file ) )
			$msg .= DEBUG_FILE.' '. basename($err_file).' ('.$err_file.')'."\n";
		if ( !empty( $err_line ) )
   		 	$msg .= DEBUG_LINE.' '.$err_line.''."\n";
   		 //."Function: ".__FUNCTION__."\n"
   		 //."Query: $sql\n"
   		 $msg .= DEBUG_REQUEST.' '.$debug_text;
		//email::send( $adminmail, 'Debug Maximus', $adminmail, $subject, $msg);
		$msg = secure( $msg, '', '', 'xss' );
		if (defined('ADMIN_ALLOW')) echo $msg.'<br/>';
		//$GLOBALS['db']->query("INSERT INTO `".TABLE_ERRORS."` values (NULL, now(), '$msg', '$u_id', '$u_name', '".MAX_URL."', '".GET_IP."')");
	}


if ( UserLastVisit_Status === true AND defined('USER_ALLOW') )
	$db->query('UPDATE `'.TABLE_USERS.'` SET `last_visit`=now() WHERE `user_id`='.secure( $userinfo['user_id'], 'num' ) );

FUNCTION code_accessibilite() {
	echo "<img src='./?gfx2=gfx2' border='0' alt='"._SECURITYCODE."' title='"._SECURITYCODE."' />";
	if ( CodeAccessible_Status === true ) {
		$tmp = INCLUDE_PATH.'kernel/popup.php';
		( is_file( $tmp ) ) ? include_once( $tmp ) : die( DIE_INCLUDE.' '.__LINE__ );
		echo "&nbsp;<a href=\"./?op=accessibilite\" onclick=\"NewsReadWindow(this.href,'ReadArticle','300','150','yes');return false;\"  title=\""._CODE_ACCESSIBILITE."\"><img src='images/handicap-20.png' border='0' alt='"._CODE_ACCESSIBILITE."' /></a>";
	}
}