<?php
/************************************************************************/
/* Minimus Blog: Web Portal System                                      */
/* ===============================                                      */
/* Write by Cyril Levert                                                */
/* Copyright (c) 2009                                                   */
/* http://www.php-minimus.org                                           */
/* dev@php-minimus.org                                                  */
/*                                                                      */
/* This program is free software.                                       */
/************************************************************************/
/* Based on PHP-Maximus: Web Portal System                              */
/************************************************************************/
defined('MINIMUS') or die ('Access denied users MINIMUS directly...');

$tmp = INCLUDE_PATH.'kernel/perso/users.php';
if ( is_file( $tmp ) ) include_once( $tmp );

if(isset($user)) {
	$user = strip_tags( $user );
	$user = base64_decode($user);
	$user = addslashes($user);
	$user = base64_encode($user);
} else {
	$user ='';
}

if(isset($admin)) {
		$admin = strip_tags( $admin );
		$admin = base64_decode($admin);
		$admin = addslashes($admin);
		$admin = explode(':', $admin);
}

if( ! function_exists('Is_User') ) {
	Function Is_User($user) {
    		if (empty($user)) return NULL;
    		global $userSave;
    		if (isset($userSave)) return $userSave;
    		if (!is_array($user)) {
			 $user = strip_tags( $user );
       			 $user = base64_decode($user);
       			 $user = addslashes($user);
        		 $user = explode(':', $user);
    		}
   		$uid = secure( $user[0], 'num');
   		$pwd = secure( $user[2], 'strip', '', 'xss' );
    		if (!empty($uid) AND !empty($pwd)) {
			if ( @ empty( $_SESSION['test_is_user'][$uid] ) ) {
				@ $_SESSION['test_is_user'][$uid] = 1;
				$row = $GLOBALS['db']->get_object('SELECT `user_password` FROM `'.TABLE_USERS.'` WHERE (`user_id`="'.$uid.'" AND `user_active`=1  )'); // AND `user_level`>=1
				$row->user_password = secure( $row->user_password, 'strip', 'clean' );
				if ($row->user_password == $pwd && !empty($row->user_password)) {
					@ $_SESSION['is_user'][$uid] = true;
					static $userSave = 1;
					return $userSave = 1;
				} else {
					@ $_SESSION['is_user'][$uid] = false;
					static $userSave = 0;
					return $userSave = 0;
				}
			} else {
				return	@ $_SESSION['is_user'][$uid];

			}
    		}
    		static $userSave = 0;
    		return $userSave = 0;
	}
}

if ( is_user($user) ) define('USER_ALLOW', true);

if( ! function_exists('CookieDecode') ) {
	Function CookieDecode( $user ) {
   		if ( !defined('USER_ALLOW') ) return NULL;
   		if (empty($user)) return NULL;
   		global $cookie;
   		static $pass;
    		if(!is_array($user)) {
			$user   = strip_tags( $user );
        		$user   = base64_decode($user);
        		$user   = secure( $user, '', '', 'xss' );
        		$cookie = explode(':', $user);
    		} else {
        		$cookie = secure( $user, '', '', 'xss' );
    		}
		if ( ! @ empty( $_SESSION['cookiedecode'] ) && $cookie[2] == @$_SESSION['cookiedecode'] )
			return $cookie;
    		if ( !isset($pass) ) {
      			if ( !isset( $cookie[0] ) ) { $cookie[1] = ''; }
       			if ( !isset( $cookie[2] ) ) { $cookie[2] = ''; }
			if ( $row = $GLOBALS['db']->get_object('SELECT `user_password` FROM `'.TABLE_USERS.'` WHERE ( `user_id`="'.$cookie[0].'"  AND `user_active`=1  )') ) { //AND `user_level`>=1
       				$user_password = secure( $row->user_password, 'strip', 'clean' );
				@ $_SESSION['cookiedecode'] = $user_password ;
       			} else {
				$user_password = '';
				@ $_SESSION['cookiedecode'] = '' ;
       			}
		}
    	if ($cookie[2] == $user_password && !empty( $user_password )) return $cookie;
	}
}

if( ! function_exists('GetUsrinfo') ) {
	Function GetUsrinfo($user) {
    		if ( !defined('USER_ALLOW') ) return NULL;
    		if (empty($user)) return NULL;
    		if (isset($userinfo)) return $userinfo;
    		global $userinfo, $cookie, $admin;
		cookiedecode($user);
		$cookie[1] = secure( $cookie[1], '', '', 'xss');
		$cookie[2] = secure( $cookie[2], '', '', 'xss');
		if ( @ empty( $_SESSION['GetUsrinfo'][$cookie[2]] ) ) {
			$userrow = $GLOBALS['db']->get_row("SELECT * FROM `".TABLE_USERS."` WHERE ( `username`='$cookie[1]' AND `user_password`='$cookie[2]' AND `user_active`=1 )"); // AND `user_level`>='1'
			$_SESSION['GetUsrinfo'][$cookie[2]] = $userrow;
		} else {
			$userrow = $_SESSION['GetUsrinfo'][$cookie[2]];
		}
		if ( ! empty( $userrow ) ) {
			if ( defined('USER_ALLOW') AND @intval($admin[0]) == 1 AND $admin[1] == COOKIE_ADMIN_KEY AND $userrow['adjoint'] == 1 ) define('ADMIN_ALLOW', true );
        		static $userinfo;
        		return $userinfo = $userrow;
    		} else {
      			return $userinfo = false;
		}
	}
}



if( ! function_exists('Is_God') ) {
	Function Is_God() {
		if ( ADMIN_ALLOW === true AND @intval($admin[0]) == 1 AND $admin[1] == COOKIE_ADMIN_KEY AND $userrow['adjoint'] == 1 ) { return true; } else { return false; }
	}
}