<?php
/************************************************************************/
/* Minimus Blog: Web Portal System                                      */
/* ===============================                                      */
/* Write by Cyril Levert                                                */
/* Copyright (c) 2009-2010                                              */
/* http://www.php-minimus.org                                           */
/* dev@php-minimus.org                                                  */
/*                                                                      */
/* This program is free software.                                       */
/************************************************************************/
/* Based on PHP-Maximus: Web Portal System                              */
/************************************************************************/
defined('MINIMUS') OR die ('Access denied config_template.php');
if ( ! defined('ADMIN_ALLOW') ) redirect_url( MyA_URL );

define('TRANSITION_JS', true);

isset($type) ? $type = secure( $type, '', '', 'clean' ) : $type = '';
isset($xmodules) ? $xmodules = secure( $xmodules, '', '', 'clean' ) : $xmodules = '';
isset($xthemes) ? $xthemes = secure( $xthemes, '', '', 'clean' ) : $xthemes = '';

incoh();

Menu(6);


if ( $type != 'themes' and $type != 'modules' )
	div_error( _MA_INVALID_TYPE );

if ( $type == 'themes' and !empty( $xthemes ) and is_dir( 'themes/'.$xthemes ) and is_writable('themes/'.$xthemes ) ) {
	br( 1 );
	h( 3, _MA_OP_DELETE_THEME, 'titre');
	echo '<fieldset style="padding-left:20px"><legend>'._MA_RAPPORT_THEME.' '.$xthemes.'</legend>';
	rmdir_recurse('themes/'.$xthemes);
	rmdir( 'themes/'.$xthemes );
	if ( !is_dir('themes/'.$xthemes ) ) {
		div_succes( _MA_DELETE_THEME_IS_OK.' '.$xthemes );
	} else {
		div_error( _MA_DELETE_THEME_ISNT_OK.' '.$xthemes );
	}
	echo '</fieldset>';
	define('DELETE_TEMPLATE', true);
}

if ( ! defined('DELETE_TEMPLATE') and $type == 'themes' and !empty( $xthemes ) and ( !is_dir( 'themes/'.$xthemes ) or !is_writable('themes/'.$xthemes ) ) ) {
	div_error( _MA_DELETE_IMPOSSIBLE_THEME );
}


if ( $type == 'modules' and !empty( $xmodules ) and is_dir( 'modules/'.$xmodules ) and is_writable('modules/'.$xmodules ) ) {
	br( 1 );
	h( 3, _MA_OP_DELETE_MODULE, 'titre');
	echo '<fieldset style="padding-left:20px"><legend>'._MA_RAPPORT_MODULE.' '.$xmodules.'</legend>';

	if ( is_file( 'modules/'.$xmodules.'/remove.php' ) ) {
		$prefix_install = $prefix; $db2 = $db;
		include_once('modules/'.$xmodules.'/remove.php');
		usleep( 100000 );
	}

	rmdir_recurse('modules/'.$xmodules);
	rmdir( 'modules/'.$xmodules );
	if ( !is_dir('modules/'.$xmodules) ) {
		div_succes( _MA_DELETE_MODULE_IS_OK.' '.$xmodules );
	} else {
		div_error( _MA_DELETE_MODULE_ISNT_OK.' '.$xmodules );
	}
	echo '</fieldset>';
	define('DELETE_MODULE', true);
}

if ( ! defined('DELETE_MODULE') and  $type == 'modules' and !empty( $xmodules ) and ( !is_dir( 'modules/'.$xmodules ) or !is_writable('modules/'.$xmodules ) ) ) {
	div_error( _MA_DELETE_IMPOSSIBLE_MODULE );
}

!empty( $xmodules ) ? $th = $xmodules : $th = $xthemes;
echo "<meta http-equiv=\"refresh\" content=\"1;url=".MyA_URL."&op=config_minimus&remove=$type&th=$th\">"
	."<meta http-equiv=\"Pragma\" content=\"no-cache\">";

incof();
