<?php
/************************************************************************/
/* Minimus Blog: Web Portal System                                      */
/* ===============================                                      */
/* Write by Cyril Levert                                                */
/* Copyright (c) 2009-2010                                              */
/* http://www.php-minimus.org                                           */
/* dev@php-minimus.org                                                  */
/*                                                                      */
/* This program is free software.                                       */
/************************************************************************/
/* Based on PHP-Maximus: Web Portal System                              */
/************************************************************************/
defined('MINIMUS') OR die ('Access denied create_it.php');
if ( defined('USER_ALLOW') ) redirect_url(MyA_URL);

if ( secure( $config['allow_new_account'], 'bin') == 0 ) redirect_url(MyA_URL);

Secure_Empty( GET_IP );
Secure_Empty( USER_AGENT );
Secure_Empty( get_remote_addr() );
Control_Access( 'Come back see an other page ...');
isset( $username ) ? $username = secure( $username, '', 'hard', 'xss') : $username= '';
isset( $email ) ? $email = secure( $email, '', 'hard', 'xss') : $email = '';
isset( $user_password ) ? $user_password = secure( $user_password, '', 'hard', 'xss') :

$code = '';
if( ! empty( $_SESSION['securecode'] ) ) {
	$random_num = secure( $_SESSION['securecode'], 'num');
	$datekey  = @date('L F j');
	$_SERVER['HTTP_USER_AGENT'] = htmlentities( check_html( $_SERVER['HTTP_USER_AGENT'], 'nohtml' ) );
	$rcode    = @md5($_SERVER['HTTP_USER_AGENT'] . $sitekey . $random_num . $datekey);
	$code     = substr($rcode, 2, 6);
}

if ( $code != $gfx_check ) {
	define('TRANSITION_JS', true);
	incoh();
	br(2);
	Div_Error( _WRONG_CODE );echo $code .'='.$gfx_check ;
	br(2);
	Go_Back();
	br(2);
	incof();
}

$num = $GLOBALS['db']->get_object("SELECT `user_id` FROM `".TABLE_USERS."` WHERE `user_email` = '$email'");
if ( !empty( $num ) ) {
	define('TRANSITION_JS', true);
	incoh();
	br(2);
	Div_Error( _WRONG_EMAIL_EXISTS );
	br(2);
	Go_Back();
	br(2);
	incof();
}
$num1 = $GLOBALS['db']->get_object("SELECT `user_id` FROM `".TABLE_USERS."` WHERE `username` = '$username'");
if ( !empty( $num1 ) ) {
	define('TRANSITION_JS', true);
	incoh();
	br(2);
	Div_Error( _WRONG_PSEUDO_EXISTS );
	br(2);
	Go_Back();
	br(2);
	incof();
}

$num = '';

if ( empty( $user_password ) ) { die('1');redirect_url(MyA_URL); die(); }
if ( empty( $email) ) { die('2');redirect_url(MyA_URL); die(); }
if(strlen($email) < 7 || !preg_match("/\w+([-+.]\w+)*@\w+([-.]\w+)*\.\w+([-.]\w+)*/", $email)) { die('3');redirect_url(MyA_URL); die(); }

if ( secure( $config['email_new_account'], 'bin') == 0 ) {
	$sql = $db->query("INSERT INTO `".TABLE_USERS."` VALUES(NULL,'$username','$email','".sha1($user_password)."','',1,0,'".$config['language']."',now(), now() )");
	op_database::optimize( TABLE_USERS );

	if ( is_module('Fluxbb') ) {
		$sql2 = 'SELECT `conf_name`, `conf_value` FROM `'.$prefix.'_fluxbb_config` ';
		foreach( $GLOBALS['db']->get_list_object( $sql2 ) as $row ) {
			$row->conf_name  = secure( $row->conf_name, 'strip', 'clean');
			$row->conf_value = secure( $row->conf_value, 'strip', 'clean');
			$config[$row->conf_name] = $row->conf_value;
		}

		$db->query("INSERT INTO `".$prefix."_fluxbb_users` SET `id`=NULL, `group_id`=4, `username`='$username', `password`='".sha1($user_password)."', `email`='$email', `email_setting`=1, `save_pass`=1, `show_smilies`=1, `show_img`=1, `show_avatars`=1, `show_sig`=1, `language`='".$config['o_default_lang']."', `style`='".$config['o_default_style']."', `registered`='".time()."', `registration_ip`='".GET_IP."', `last_visit`='".time()."' ");
	}

	if ( is_module('Twitter') ) {
		$tmp = 'modules/Twitter/functions/constants.php';
		if ( is_file( $tmp ) ) include_once( $tmp );

		$ident = $db->get_object("SELECT `user_id` FROM `".TABLE_USERS."` WHERE `user_email` = '".$email. "' ");
		$ident->user_id = secure( $ident->user_id, 'num' );
		$num = $db->get_num("SELECT `id` FROM `".TABLE_TWITTER_ACCOUNT."` WHERE `uid` = '".$ident->user_id. "' ");
		if ( empty( $num ) )
			$db->query("INSERT INTO `".TABLE_TWITTER_ACCOUNT."` ( `id`, `uid`, `who`, `xtime`, `datetime`, `active`, `total` ) VALUES (NULL, '".$ident->user_id. "' , '".$username."', '".secure( time(), 'num')."', now(), 1, 0 )") or die( mysql_error() );
		op_database::optimize( TABLE_TWITTER_ACCOUNT );
	}

	if ( !empty( $sql ) ) {
		$sql = "SELECT * FROM `".TABLE_USERS."` WHERE `user_email` = '$email'";
		$infouser = $GLOBALS['db']->get_object( $sql );

		$info = base64_encode( $infouser->user_id.':'.$infouser->username.':'.$infouser->user_password );
		setcookie('user',$info,time()+31536000);

		$sql1 = "SELECT `id` FROM `".$prefix."_fluxbb_users` WHERE `username`='".$infouser->username."' AND `email`='$email' AND `password`='".$infouser->user_password."' ";
		$allowflux = $GLOBALS['db']->get_num( $sql1 );
		if ( !empty( $allowflux ) ) {
			$infoflux = $GLOBALS['db']->get_object( $sql1 );
			/** identification fluxbb */
			setcookie('forum_cookie', serialize(array($infoflux->id, md5(COOKIE_FLUXBB.''.$infouser->user_password))), time() + 31536000);
			/** fin fluxbb */
		}
		redirect_url(MyA_URL.'&op=userinfo');die();
	} else {
		redirect_url(MyA_URL.'&stop=1&username='.$username);
	}
} else {
	$date = date('Y-m-d G:i:s');
	$db->query("INSERT INTO `".TABLE_USERS."` VALUES(NULL,'$username','$email','".sha1($user_password)."','',0,0,'".$config['language']."',now(), '$date' )");
	op_database::optimize( TABLE_USERS );

	if ( is_module('Fluxbb') ) {
		$sql2 = 'SELECT `conf_name`, `conf_value` FROM `'.$prefix.'_fluxbb_config` ';
		foreach( $GLOBALS['db']->get_list_object( $sql2 ) as $row ) {
			$row->conf_name  = secure( $row->conf_name, 'strip', 'clean');
			$row->conf_value = secure( $row->conf_value, 'strip', 'clean');
			$config[$row->conf_name] = $row->conf_value;
		}

		$db->query("INSERT INTO `".$prefix."_fluxbb_users` SET `id`=NULL, `group_id`=4, `username`='$username', `password`='".sha1($user_password)."', `email`='$email', `email_setting`=1, `save_pass`=1, `show_smilies`=1, `show_img`=1, `show_avatars`=1, `show_sig`=1, `language`='".$config['o_default_lang']."', `style`='".$config['o_default_style']."', `registered`='".time()."', `registration_ip`='".GET_IP."', `last_visit`='".time()."' ");
		op_database::optimize( $prefix.'_fluxbb_users' );
	}

	if ( is_module('Twitter') ) {
		$tmp = 'modules/Twitter/functions/constants.php';
		if ( is_file( $tmp ) ) include_once( $tmp );

		$ident = $db->get_object("SELECT `user_id` FROM `".TABLE_USERS."` WHERE `user_email` = '".$email. "' ");
		$ident->user_id = secure( $ident->user_id, 'num' );
		$num = $db->get_num("SELECT `id` FROM `".TABLE_TWITTER_ACCOUNT."` WHERE `uid` = '".$ident->user_id. "' ");
		if ( empty( $num ) )
			$db->query("INSERT INTO `".TABLE_TWITTER_ACCOUNT."` ( `id`, `uid`, `who`, `xtime`, `datetime`, `active`, `total` ) VALUES (NULL, '".$ident->user_id. "' , '".$username."', '".secure( time(), 'num')."', now(), 0, 0 )") or die( mysql_error() );
		op_database::optimize( TABLE_TWITTER_ACCOUNT );
	}

	$finishlink   = 'http://'.URL_SITE.'/'.MyA_URL.'&op=activate&uname='.$username.'&checkit='.md5($date).'&amp;step=2';
	$message = _MA_WELCOMETO." $sitename (".URL_SITE.")!\r\n\r\n";
	$message .= _MA_YOUUSEDEMAIL." $email.\r\n\r\n";
	$message .= _MA_TOFINISHUSER."\r\n\r\n$finishlink\r\n\r\n";
	$message .= _MA_FOLLOWINGMEM."\r\n"._MA_UNICKNAME." $username\r\n"._MA_PASSWORD." $user_password\r\n";
	$subject = _MA_ACTIVATIONSUB." $sitename\r\n";
	$message = html_entity_decode( $message );
	email::send( $email, $adminmail, $adminmail, $subject, $message);
	redirect_url(MyA_URL.'&op=activate&step=1');die();
}