<?php
/************************************************************************/
/* PHP Kweeker / Minimus: Web Portal System                             */
/* ========================================                             */
/* Write by Cyril Levert                                                */
/* Copyright (c) 2009 - 2010                                            */
/* PHP Kweeker : http://twitter.php-minimus.org                         */
/* Blog and CMS : http://www.php-minimus.org                            */
/* dev@php-minimus.org                                                  */
/* Write by: Cyril Levert                                               */
/*                                                                      */
/* This program is free software.                                       */
/************************************************************************/
/* Based on PHP-Maximus: Web Portal System                              */
/************************************************************************/
defined('MINIMUS') or Header('Location: ../../index.php');

$module_name = basename(dirname(__FILE__));
get_lang ( MODULE_NAME );
define('FOLDER_MODULE', 'modules/'.MODULE_NAME.'/');

$tmp = FOLDER_MODULE.'functions/constants.php';
if ( is_file( $tmp ) ) include_once( $tmp );

$tmp = FOLDER_DATAS.'variables.php';
if ( is_file( $tmp ) ) include_once( $tmp );

if ( $rewrite == 1 ) define('URL_REWRITING', true);

if ( defined('ADMIN_ALLOW') ) {
	$tmp = FOLDER_GESTION.'switch.php';
	if ( is_file( $tmp ) ) include_once( $tmp );
}

isset( $page ) ? $page = secure( $page, 'num') : $page = '';
isset( $kweek ) ? $kweek = secure( $kweek, '', '', 'xss') : $kweek = '';
isset( $who ) ? $who = secure( $who, '', '', 'xss') : $who = '';

FUNCTION update_total_user( $qui ) {
	if ( @ empty( $_SESSION['update_total_user'][$qui] ) ) {
		if ( !empty( $qui) ) {
			global $db;
			$num = $db->get_num("SELECT `id` FROM `".TABLE_TWITTER."` WHERE ( `who`= '". secure( $qui, '', '', 'xss'). "' OR `reponse`= '". secure( $qui, '', '', 'xss'). "' ) AND `active`= 1 ");
			$db->query("UPDATE `".TABLE_TWITTER_ACCOUNT."` SET `total`='".$num."' WHERE `who` = '". secure( $qui, '', '', 'xss'). "' ");
			op_database::optimize( TABLE_TWITTER_ACCOUNT );
			@ $_SESSION['update_total_user'][$qui] = 1;
		}
	}
}

FUNCTION get_number_kweeks( $who ) {
	if ( @ empty( $_SESSION['get_number_kweeks_test'][$who] ) ) {
		global $db;
		$ADD = '';
		if ( !empty( $who ) ) $ADD = "`who`='".addslashes( $who )."' AND";
		$num = $db->get_num("SELECT `id` FROM `".TABLE_TWITTER."` WHERE $ADD `active` = 1 ");
		@ $_SESSION['get_number_kweeks'][$who] = $num ;
		@ $_SESSION['get_number_kweeks_test'][$who] = 1 ;
		return $num;

	} else {
		return intval( @ $_SESSION['get_number_kweeks'][$who] );
	}
}

FUNCTION is_kweeker() {
	global $cookie, $db;
	if ( @ empty( $_SESSION['allow_kweeker_test'] ) ) {
		$num = $db->get_num("SELECT `id` FROM `".TABLE_TWITTER_ACCOUNT."` WHERE `uid` = '". secure( $cookie[0], '', '', 'xss'). "' AND `active`= 1 ");
		( !empty( $num ) ) ? define('ALLOW_KWEEKER', true) : define('ALLOW_KWEEKER', false);
		( !empty( $num ) ) ? $test = 1 : $test = 0;
		@ $_SESSION['allow_kweeker'] = $test ;
		@ $_SESSION['allow_kweeker_test'] = 1 ;
	} else {
		( intval( $_SESSION['allow_kweeker'] ) ) ? define('ALLOW_KWEEKER', true ) : define('ALLOW_KWEEKER', false);
	}
}

is_kweeker();

FUNCTION pagination( $total, $courante, $position=false ) {
	$total    = secure( $total, 'num');
	$courante = secure( $courante, 'num');
	$position = secure( $position, '', 'clean', 'sec' );
	if ( ! preg_match( '(left|center|right)', $position ) ) { $position = 'right'; }
	/* on dfinit quelques variables dont on aura besoin */
	$prec = $courante - 1; // numro de la page prcdente
	$suiv = $courante + 1; // numro de la page suivante
	$avder = $total - 1; // avant dernire page
	$adjacentes = 2; // nombre de pages  afficher de chaque ct de la page courante
	$pagination = ''; // s'il n'ya pas au moins deux pages, on n'affiche rien

	if($total > 1)  {
		$pagination .= "<div class='pagination' align='$position'>\n";
		/*if ( defined('PAGE_BILLET') ) {
			$pagination.= "<span class='desactivepage'>"._BILLET_INCLUDES." <strong>$total</strong> "._PAGES."</span>";
		}*/
		//$pagination.= "<span class='desactivepage'>"._PAGE." <strong>$courante</strong> "._PAGE_ON." $total</span>";
		if ($courante == 2)
			$pagination.= "<a href=\"".PAGE_LINK."\">"._PAGE_PREVIOUS."</a>";
		elseif ($courante > 2)
			$pagination.= "<a href=\"".PAGE_LINK."&amp;page=$prec\"> prc</a>";
		else
			$pagination.= "<span class='desactive'>"._PAGE_PREVIOUS."</span>";

		if ($total < 7 + ($adjacentes * 2))  {
			$pagination.= ($courante == 1) ? "<span class='courante'>1</span>" : "<a href=\"".PAGE_LINK."\">1</a>";

			for ($compteur = 2; $compteur <= $total; $compteur++)            {
				if ($compteur == $courante)
				$pagination.= "<span class='courante'>$compteur</span>";
				else
				$pagination.= "<a href=\"".PAGE_LINK."&amp;page=$compteur\">$compteur</a>";
			}
		}

		elseif($total > 5 + ($adjacentes * 2)) {
			if($courante < 1 + ($adjacentes * 2)) {
			$pagination.= ($courante == 1) ? "<span class='courante'>1</span>" : "<a href=\"".PAGE_LINK."\">1</a>";
			for ($compteur = 2; $compteur < 4 + ($adjacentes * 2); $compteur++) {
				if ($compteur == $courante)
					$pagination.= "<span class='courante'>$compteur</span>";
				else
					$pagination.= "<a href=\"".PAGE_LINK."&amp;page=$compteur\">$compteur</a>";
			}
			$pagination.= ' ... ';
			$pagination.= "<a href=\"".PAGE_LINK."&amp;page=$avder\">$avder</a>";
			$pagination.= "<a href=\"".PAGE_LINK."&amp;page=$total\">$total</a>";
		}
		elseif($total - ($adjacentes * 2) > $courante && $courante > ($adjacentes * 2))
		{
			$pagination.= "<a href=\"".PAGE_LINK."\">1</a>";
			$pagination.= "<a href=\"".PAGE_LINK."&amp;page=2\">2</a>";
			$pagination.= " ... ";
			for ($compteur = $courante - $adjacentes; $compteur <= $courante + $adjacentes; $compteur++)
			{
			if ($compteur == $courante)
				$pagination.= "<span class='courante'>$compteur</span>";
			else
				$pagination.= "<a href=\"".PAGE_LINK."&amp;page=$compteur\">$compteur</a>";
			}
			$pagination.= ' ... ';
			$pagination.= "<a href=\"".PAGE_LINK."&amp;page=$avder\">$avder</a>";
			$pagination.= "<a href=\"".PAGE_LINK."&amp;page=$total\">$total</a>";
		}
		else
		{
			$pagination.= "<a href=\"".PAGE_LINK."\">1</a>";
			$pagination.= "<a href=\"".PAGE_LINK."&amp;page=2\">2</a>";
			$pagination.= ' ... ';
			for ($compteur = $total - (2 + ($adjacentes * 2)); $compteur <= $total; $compteur++)
			{
			if ($compteur == $courante)
				$pagination.= "<span class='courante'>$compteur</span>";
			else
				$pagination.= "<a href=\"".PAGE_LINK."&amp;page=$compteur\">$compteur</a>";
			}
		}
		}
		if ($courante < $compteur - 1)
		$pagination.= "<a href=\"".PAGE_LINK."&amp;page=$suiv\">"._PAGE_NEXT."</a>\n";
		else
		$pagination.= "<span class='desactive'>"._PAGE_NEXT."</span>\n";
		$pagination.= "</div>\n";
	}
	echo $pagination;
}

FUNCTION security_files() {
	if ( ! file_exists( FOLDER_AVATARS.'index.php') )
		copy (FOLDER_SECURITY.'index.php', FOLDER_AVATARS.'index.php');
	if ( ! file_exists( FOLDER_AVATARS.'index.html') )
		copy (FOLDER_SECURITY.'index.html', FOLDER_AVATARS.'index.html');
	if ( ! file_exists( FOLDER_AVATARS.'.htaccess') )
		copy ( FOLDER_SECURITY.'.htaccess', FOLDER_AVATARS.'.htaccess');
}

FUNCTION Reponse_Who( $text ) {
	$in = array( '`@([a-zA-Z0-9_]+)`');
	if ( defined('URL_REWRITING') ) {
		$out =  array(
			'@<a class="pseudo" title="$1" href="twitter-$1.html">$1</a> '
		);
	} else {
		$out =  array(
			'@<a class="pseudo" title="$1" href="'.URL_MODULE.'&amp;kweek=$1">$1</a> '
		);
	}
	return preg_replace( $in, $out, $text);
}

FUNCTION bb_kill( $string ) {
	$patterns = array(
		'`\[code\](.+?)\[/code\]`is',
		'`\[blink\](.+?)\[/blink\]`is',
		'`\[big\](.+?)\[/big\]`is',
		'`\[small\](.+?)\[/small\]`is',
		'`\[sup\](.+?)\[/sup\]`is',
		'`\[sub\](.+?)\[/sub\]`is',
		'`\[del\](.+?)\[/del\]`is',
		'`\[b\](.+?)\[/b\]`is',
		'`\[i\](.+?)\[/i\]`is',
		'`\[u\](.+?)\[/u\]`is',
		'`\[strike\](.+?)\[/strike\]`is',
		'`((?:https?|ftp)://\S+[[:alnum:]]/?)`si',
		'`((?<!//)(www\.\S+[[:alnum:]]/?))`si',
		'`\[wp:(.+?)\]`is',
		'`\[google:(.+?)\]`is',
		'`\[php:(.+?)\]`is',
		'`\[youtube\](.+?)\[/youtube\]`si'
	);
	$string = preg_replace($patterns,'\\1',$string);
	return  $string ;
}

FUNCTION clickable( $url ){
	$in = array(
		'`\[code\](.+?)\[/code\]`is',
		'`\[blink\](.+?)\[/blink\]`is',
		'`\[big\](.+?)\[/big\]`is',
		'`\[small\](.+?)\[/small\]`is',
		'`\[sup\](.+?)\[/sup\]`is',
		'`\[sub\](.+?)\[/sub\]`is',
		'`\[b\](.+?)\[/b\]`is',
		'`\[i\](.+?)\[/i\]`is',
		'`\[u\](.+?)\[/u\]`is',
		'`\[strike\](.+?)\[/strike\]`is',
		'`((?:https?|ftp)://\S+[[:alnum:]]/?)`si',
		'`((?<!//)(www\.\S+[[:alnum:]]/?))`si',
		'`\[wp:(.+?)\]`is',
		'`\[google:(.+?)\]`is',
		'`\[php:(.+?)\]`is',
		'`\[youtube\](.+?)\[/youtube\]`si'
	);
	$out =  array(
		'<code>\\1</code>',
		'<blink>\\1</blink>',
		'<big>\\1</big>',
		'<small>\\1</small>',
		'<sup>\\1</sup>',
		'<sub>\\1</sub>',
		'<strong>\\1</strong>',
		'<em>\\1</em>',
		'<u>\\1</u>',
		'<strike>\\1</strike>',
		'<a class="pseudo" title="$1" href="$1" '.KWEEKS_NO_FOLLOW.' '.KWEEKS_TARGET.'>$1</a>',
		'<a class="pseudo" title="$1" href="http://$1" '.KWEEKS_NO_FOLLOW.' '.KWEEKS_TARGET.'>$1</a>',
		'<a href="http://fr.wikipedia.org/wiki/$1" class="wikipedia" title="Wikipedia: $1">$1</a>',
		'<a href="http://www.google.fr/search?source=ig&amp;hl=fr&amp;rlz=&amp;=&amp;q=$1" title="Google: $1" class="googlelink">$1</a>',
		'<a href="http://fr.php.net/manual/fr/function.$1.php" class="phpnet" title="PHP: $1">$1</a>',
		'<div class="youtube"><object width="'.YOUTUBE_WIDTH.'" height="'.YOUTUBE_HEIGHT.'"><param name="movie" value="http://www.youtube.com/v/$1"></param><param name="allowFullScreen" value="true"></param><param name="allowscriptaccess" value="always"></param><embed src="http://www.youtube.com/v/\1" type="application/x-shockwave-flash" allowscriptaccess="always" allowfullscreen="true" width="'.YOUTUBE_WIDTH.'" height="'.YOUTUBE_HEIGHT.'"></embed></object></div>'
	);
	return preg_replace( $in, $out, Reponse_Who( $url ) );
}

FUNCTION menu_lateral(){
	global $db, $cookie, $kweek, $main_module;

	if ( !empty( $kweek ) AND !defined('ACCOUNT_CLOSED') ) {
		echo '<div id="boite_pseudo">';
		$sql = "SELECT `id`, `nom`, `photo`, `local`, `web`, `bio` FROM `".TABLE_TWITTER_ACCOUNT."` WHERE `who` = '". secure( $kweek, '', '', 'xss'). "'  ";

		$row = $db->get_object( $sql ) or die( mysql_error() );

		$row->id    = secure( $row->id, 'num');
		$row->nom   = secure( $row->nom, 'strip', 'clean');
		$row->photo = secure( $row->photo, 'strip', 'clean');
		$row->local = secure( $row->local, 'strip', 'clean');
		$row->web   = secure( $row->web, 'strip', 'clean');
		$row->bio   = secure( $row->bio, 'strip', 'clean');

		$sql = "SELECT `id` FROM `".TABLE_TWITTER."` WHERE ( `who` = '". secure( $kweek, '', '', 'xss'). "' OR `reponse` = '". secure( $kweek, '', '', 'xss'). "' ) AND `active`= 1 ";
		$num = $db->get_num( $sql );

		if ( ! empty( $row->photo ) AND is_file( FOLDER_AVATARS.''.$row->photo ) )
			echo '<img src="'.FOLDER_AVATARS.''.$row->photo.'" alt="" style="float:left;margin-right:10px;" />'."\n";
		else
			echo '<img src="'.AVATAR_DEFAULT.'" alt="" style="float:left;margin-right:10px;" />'."\n";

		echo '<div><span style="color:#808080">'._PSEUDO.'</span> <strong>'.$kweek.'</strong></div>';
		if ( !empty( $row->nom ) )
			echo '<div><span style="color:#808080">'._USERNAME.'</span> <strong>'.$row->nom.'</strong></div>';
		if ( !empty( $row->local ) )
			echo '<div><span style="color:#808080">'._LOCALISATION.'</span> <strong>'.$row->local.'</strong></div>';

		echo '<div> '.$num.' '._KWEEKS.'</div>';

		br( 1 );
		if ( ! empty( $row->web ) )
			echo '<strong>Web</strong> <a class="pseudo" title="'.$row->web.'" href="http://'.$row->web.'" '.KWEEKS_PROFIL_NO_FOLLOW.' '.KWEEKS_PROFIL_TARGET.'>'.$row->web.'</a>';

		br( 1 );
		if ( ! empty( $row->bio ) )
			echo '<strong>'._BIO.'</strong> '. $row->bio;

		echo '</div>';
	}

	echo '<div class="boite" id="menubox"><ul>';
	/*if ( @ empty( $_SESSION['get_row_account_test'][$cookie[0]] ) ) {
		$row1 = $db->get_row("SELECT `id` FROM `".TABLE_TWITTER_ACCOUNT."` WHERE `uid` = '". secure( $cookie[0], 'num'). "' ");
		@ $_SESSION['get_row_account'][$cookie[0]] = $row1 ;
		@ $_SESSION['get_row_account_test'][$cookie[0]] = 1 ;
	} else {
		$row1 = @ $_SESSION['get_row_account'][$cookie[0]];
	}*/

	if( $main_module == MODULE_NAME ) {
		echo '<li><a href="./" title="'._HOME_KWEEKER.'"> '._HOME_KWEEKER.' </a></li>';
	} else {
		( defined('URL_REWRITING') ) ? $url = 'twitter.html' : $url = URL_MODULE;
		echo '<li><a href="'.$url.'" title="'._HOME_KWEEKER.'"> '._HOME_KWEEKER.' </a></li>';
	}

	if ( is_file( FOLDER_DATAS.'help.php' ) ) {
		( defined('URL_REWRITING') ) ? $url = 'twitter_help.html' : $url = URL_MODULE.'&amp;op=help';
		echo '<li><a href="'.$url.'" title="'._KWEEKS_HELP.'"> '._KWEEKS_HELP.' </a></li>';
	}
	/*if ( empty( $row1 ) ) {
		if ( defined('USER_ALLOW') ) {
			( defined('URL_REWRITING') ) ? $url = 'twitter_create.html' : $url = URL_MODULE.'&amp;op=create';
			echo '<li><a href="'.$url.'" title="'._CREATE_KWEEKER.'">'._CREATE_KWEEKER.'</a></li>';
		} else {
			( defined('URL_REWRITING') ) ? $url = 'twitter_create.html' : $url = 'index.php?name=MyAccount';
			echo '<li><a href="'.$url.'" title="'._CREATE_KWEEKER.'">'._CREATE_KWEEKER.'</a></li>';
		}
	} else {*/
	if ( defined('USER_ALLOW') ) {
		( defined('URL_REWRITING') ) ? $url = 'twitter-'.$cookie[1].'.html' : $url = URL_MODULE.'&amp;kweek='.$cookie[1];
		echo '<li><a href="'.$url.'" title="'._MY_KWEEKER.'">'._MY_KWEEKER.'</a></li>';

		( defined('URL_REWRITING') ) ? $url = 'twitter_profil-'.$cookie[1].'.html' : $url = URL_MODULE.'&amp;op=profil';
		echo '<li><a href="'.$url.'" title="'._MY_PROFIL.'">'._MY_PROFIL.' &raquo;  <strong>'.$cookie[1].'</strong></a></li>';
	}
	//}

	( defined('URL_REWRITING') ) ? $url = 'twitter_somebody.html' : $url = URL_MODULE.'&amp;op=somebody';
	echo '<li><a href="'.$url.'" title="'._SEARCH_SOMEBODY.'">'._SEARCH_SOMEBODY.'</a></li>';

	if ( defined('ADMIN_ALLOW') ) {
		( defined('URL_REWRITING') ) ? $url = 'twitter_admin_kweek.html' : $url = URL_MODULE.'&amp;op=admin_kweek';
		echo '<li><a href="'.$url.'" title="'._ADMINISTRATION.'">&raquo;&raquo; '._ADMINISTRATION.'</a></li>';
	}

	echo '</ul>';
	br( 1 );

	( defined('URL_REWRITING') ) ? $url = 'twitter_search.html' : $url = URL_MODULE.'&amp;op=search';
	echo "<form action='".$url."' method='post' name=\"search\" onsubmit=\"return emptysearch()\">"
	."<input id='inputsearch' type='text' name='query' value='"._SEARCH."' onfocus=\"if (this.value=='"._SEARCH."') {this.value=''}\" onblur=\"if (this.value=='') this.value='"._SEARCH."'\"  />"
	."<input type='submit' value='"._OK."' /></form>";

	echo '<div id="boite_rss">';
	if ( empty( $kweek ) ) {
		( defined('URL_REWRITING') ) ? $url = 'twitter_rss.html' : $url = URL_MODULE.'&amp;op=rss';
	} else {
		( defined('URL_REWRITING') ) ? $url = 'twitter_rss-'.$kweek.'.html' : $url = URL_MODULE.'&amp;op=rss&amp;who='.$kweek;
	}
	echo '<a href="'.$url.'" title="'._RSS_FLUX.'">'._RSS_FLUX;
	if ( ! empty( $kweek ) ) echo ' '._OF.' <strong>'. $kweek .'</strong>';
	echo '</a></div >';

	$tmp = ROOT_PATH.'/'.CACHE.'/Configuration/'.PREFIX_CACHE.'_cache_kweeker_menu.php';
	if ( is_file( $tmp ) ) {
		echo '<div id="boite_menu">';
		echo file_get_contents( $tmp );
		echo '</div>';
	}

	if ( BOX_LASTS_ACCOUNT === true ) {
		if ( @ empty( $_SESSION['box_lasts_accounts'] ) ) {
			$content .= '<div class="boite" id="boite_lasts_kweeks"><h3>'._LASTS_ACCOUNTS.'</h3><ul>';
			$sql = "SELECT `who`, `nom` FROM `".TABLE_TWITTER_ACCOUNT."` WHERE `active`= 1 ORDER BY `id` DESC LIMIT ".BOX_LASTS_ACCOUNT_NB;
				foreach( $db->get_list_object( $sql ) as $lasts ) {
				( defined('URL_REWRITING') ) ? $url = 'twitter-'.$lasts->who.'.html' : $url = URL_MODULE.'&amp;kweek='.$lasts->who;
				$content .= '<li><a href="'.$url.'" title="'.$lasts->nom.'">'.$lasts->who;
				if ( !empty( $lasts->nom ) ) $content .= ' <em>( '.$lasts->nom.' )</em>';
				$content .= '</a></li>';
			}
			$content .= '</ul></div>';
			@ $_SESSION['box_lasts_accounts'] = $content;
			echo $content;
		} else {
			echo @ $_SESSION['box_lasts_accounts'];
		}
	}

	if ( BOX_BESTS_ACCOUNT === true ) {
		echo '<div class="boite" id="boite_bests_kweeks"><h3>'._BESTS_ACCOUNTS.'</h3><ul>';
		$sql = "SELECT `who`, `nom`, `total` FROM `".TABLE_TWITTER_ACCOUNT."` WHERE `active`= 1 ORDER BY `total` DESC LIMIT ".BOX_BESTS_ACCOUNT_NB;
			foreach( $db->get_list_object( $sql ) as $lasts ) {
			( defined('URL_REWRITING') ) ? $url = 'twitter-'.$lasts->who.'.html' : $url = URL_MODULE.'&amp;kweek='.$lasts->who;
			echo '<li> <a href="'.$url.'" title="'.$lasts->nom.'"> '.$lasts->who.' &raquo; '.$lasts->total;
			if ( !empty( $lasts->nom ) ) echo ' <em>( '.$lasts->nom.' )</em> ';
			echo '</a></li>';
		}

		echo '</ul></div>';
	}
	echo '</div>';
}


Function generate_sitemap() {
	$datejour = date('Y-m-d');
	$contenu = '';
	$contenu .= "<url>\n";
	( defined('URL_REWRITING') ) ? $url = 'twitter.html' : $url = URL_MODULE;
	$contenu .= "<loc>http://".URL_SITE."/".$url."</loc>\n";
	$contenu .= "<lastmod>$datejour</lastmod>\n";
	$contenu .= "<changefreq>daily</changefreq>\n";
	$contenu .= "<priority>1</priority>\n";
	$contenu .= "</url>\n";

	$contenu .= "<url>\n";
	( defined('URL_REWRITING') ) ? $url = 'twitter_rss.html' : $url = URL_MODULE.'&amp;op=rss';
	$contenu .= "<loc>http://".URL_SITE."/".$url."</loc>\n";
	$contenu .= "<lastmod>$datejour</lastmod>\n";
	$contenu .= "<changefreq>daily</changefreq>\n";
	$contenu .= "<priority>1</priority>\n";
	$contenu .= "</url>\n";

	$a = 0;
	$priority = 99;
	$sql = $GLOBALS['db']->get_list_object("SELECT `who`, `datetime` FROM `".TABLE_TWITTER_ACCOUNT."` WHERE `active`=1 ORDER BY `total` DESC");
	foreach( $sql as $account ) {
		$account->who    = secure( $account ->who, 'strip', 'clean');
		$account->datetime  = secure( $account->datetime, 'strip', 'clean');
		$account->datetime  = explode(' ', $account->datetime );
		if ( empty( $account->datetime[0] ) ) { $account->datetime[0] = $datejour; }

		$contenu .= "<url>\n";
		( defined('URL_REWRITING') ) ? $url = 'twitter-'.$account->who.'.html' : $url = URL_MODULE.'&amp;kweek='.$account->who;
		$contenu .= "<loc>http://".URL_SITE."/".$url."</loc>\n";
		$contenu .= "<lastmod>".$account->datetime[0]."</lastmod>\n";
		$contenu .= "<changefreq>daily</changefreq>\n";
		if ( $a == SITEMAP_NB_ACCOUNTS ) {
			$a = 0;
			$priority = $priority - 1;
		} else {
			$a++;
		}
		$contenu .= "<priority>0.".$priority."</priority>\n";
		$contenu .= "</url>\n";

		$contenu .= "<url>\n";
		( defined('URL_REWRITING') ) ? $url = 'twitter_rss-'.$account->who.'.html' : $url = URL_MODULE.'&amp;op=rss&amp;who='.$account->who;
		$contenu .= "<loc>http://".URL_SITE."/".$url."</loc>\n";
		$contenu .= "<lastmod>".$account->datetime[0]."</lastmod>\n";
		$contenu .= "<changefreq>daily</changefreq>\n";
		$contenu .= "<priority>0.".$priority."</priority>\n";
		$contenu .= "</url>\n";
	}
	Referencement::Sitemaps( 'twitter_account', $contenu );

	$contenu = '';
	$a = 0;
	$priority = 99;
	$sql = $GLOBALS['db']->get_list_object("SELECT `id`, `datetime` FROM `".TABLE_TWITTER."` WHERE `active`=1 ORDER BY `id` DESC");
	foreach( $sql as $kweeks ) {
		$kweeks->id  = secure( $kweeks->id, 'num');
		$kweeks->datetime  = secure( $kweeks->datetime, 'strip', 'clean');
		$kweeks->datetime  = explode(' ', $kweeks->datetime );
		if ( empty( $kweeks->datetime[0] ) ) { $kweeks->datetime[0] = $datejour; }
		$contenu .= "<url>\n";

		( defined('URL_REWRITING') ) ? $url = 'twitter_id-'.$kweeks->id.'.html' : $url = URL_MODULE.'&amp;op=text&amp;id='.$kweeks->id;

		$contenu .= "<loc>http://".URL_SITE."/".$url."</loc>\n";
		$contenu .= "<lastmod>".$kweeks->datetime[0]."</lastmod>\n";
		$contenu .= "<changefreq>daily</changefreq>\n";
		if ( $a == SITEMAP_NB_KWEEKS ) {
			$a = 0;
			$priority = $priority - 1;
		} else {
			$a++;
		}
		$contenu .= "<priority>0.".$priority."</priority>\n";
		$contenu .= "</url>\n";
	}
	Referencement::Sitemaps( 'twitter_kweeks', $contenu );
}

switch( $op ) {
	//case 'kweek': include_once( FOLDER_PUBLIC.'kweek.php'); break;
	case 'help': include_once( FOLDER_PUBLIC.'help.php'); break;
	case 'profil': include_once( FOLDER_PUBLIC.'profil.php'); break;
	case 'rss': include_once( FOLDER_PUBLIC.'rss.php'); break;
	case 'search': include_once( FOLDER_PUBLIC.'search.php'); break;
	case 'somebody': include_once( FOLDER_PUBLIC.'somebody.php'); break;
	case 'text': include_once( FOLDER_PUBLIC.'text.php'); break;

	case 'create':
		if ( defined('USER_ALLOW') ) {
			$num = $db->get_num("SELECT `id` FROM `".TABLE_TWITTER_ACCOUNT."` WHERE `uid` = '". secure( $cookie[0], 'num'). "' ");
			if ( empty( $num ) )
				$db->query("INSERT INTO `".TABLE_TWITTER_ACCOUNT."` ( `id`, `uid`, `who`, `xtime`, `datetime`, `active`, `total` ) VALUES (NULL, '". secure( $cookie[0], 'num'). "' , '".secure( $cookie[1], '', '', 'xss')."', '".secure( time(), 'num')."', now(), 1, 0 )") or die( mysql_error() );
		}
		generate_sitemap();
		redirect_url( GET_REFERER );
	break;

	case 'status':
		if ( defined('ADMIN_ALLOW') ) {
			if ( !defined('ADMIN_ALLOW') ) $ADD = " AND `who`= '".secure( $cookie[1], '', '', 'xss')."'";
			$db->query("UPDATE `".TABLE_TWITTER."` SET `active`='".(int)secure( $status, 'bin')."' WHERE `id`='".secure( $id, 'num')."' $ADD");
			op_database::optimize( TABLE_TWITTER );
		}
		generate_sitemap();
		redirect_url( GET_REFERER );
	break;

	case 'delete':
		if ( defined('USER_ALLOW') ) {
			if ( !defined('ADMIN_ALLOW') ) $ADD = " AND `who`= '".secure( $cookie[1], '', '', 'xss')."'";
			$db->query("DELETE FROM `".TABLE_TWITTER."` WHERE `id`='".secure( $id, 'num')."' $ADD ");
			op_database::optimize( TABLE_TWITTER );
		}
		generate_sitemap();
		redirect_url( str_replace('&ok=1', '', URL_MODULE.'&supp=1' ) );
	break;

	case 'valid':
		$via = 'web';
		if ( defined('USER_ALLOW') && !empty( $tweet ) ) {

			isset( $response ) ? $response = secure( $response, '', 'xss') : $response = '';

			$row = $db->get_row("SELECT `photo` FROM `".TABLE_TWITTER_ACCOUNT."` WHERE `uid` = '". secure( $cookie[0], 'num'). "' ");

			$tweet = substr( $tweet, 0, SIZE_MAXI );

			$db->query("INSERT INTO `".TABLE_TWITTER."` VALUES (NULL, '".secure($tweet, '', '', 'xss')."', '".secure($cookie[1], '', '', 'xss')."', '".secure($row['photo'], '', '', 'xss')."', '$response', '".secure( $via, '', '', 'xss')."', '".secure( time(), 'num')."', now(), '".GET_IP."', 1 )");
			op_database::optimize( TABLE_TWITTER );

			generate_sitemap();

			$db->query("UPDATE `".TABLE_TWITTER_ACCOUNT."` SET `total`=total+1 WHERE `uid` = '". secure( $cookie[0], 'num'). "' ");

			op_database::optimize( TABLE_TWITTER_ACCOUNT );

			if ( PUSH_EMAIL_RESPONSE === true && ! empty( $response ) ) {
				$mail = $db->get_object("SELECT `user_email` FROM `".TABLE_USERS."` WHERE `username` = '". secure( $response, '', '', 'xss'). "' ");

				$response         = removecrlf( $response );
				$mail->user_email = removecrlf( $mail->user_email );

				( defined('URL_REWRITING') ) ? $url = 'twitter-'.$response.'.html' : $url = URL_MODULE.'&amp;kweek='.$response;

				$subject = _FRIEND_RESPONSE.' '.$cookie[1];
				$message = _FRIEND_HELLO." ".$response."\n\n $cookie[1] "._FRIEND_RESPONSE_TO."\n\n"._FRIEND_URL.": ".URL_SITE."/$url\n\n$sitename, ".URL_SITE ;

				email::send( $mail->user_email, $response, $adminmail, html_entity_decode( $subject ), html_entity_decode( $message ) );

			}
			redirect_url( str_replace('&supp=1', '', URL_MODULE.'&ok=1' ) );
		} else {
			redirect_url( GET_REFERER );
		}
	break;

	default: include_once( FOLDER_PUBLIC.'index.php'); break;
}