<?php
/************************************************************************/
/* Minimus Blog: Web Portal System                                      */
/* ===============================                                      */
/* Write by Cyril Levert                                                */
/* Copyright (c) 2009                                                   */
/* http://www.php-minimus.org                                           */
/* dev@php-minimus.org                                                  */
/*                                                                      */
/* This program is free software.                                       */
/************************************************************************/
/* Based on PHP-Maximus: Web Portal System                              */
/************************************************************************/
defined('MINIMUS') OR die ('Access denied index MyA');
$module_name = 'MyAccount';
get_lang( $module_name );

$pagetitle = _MA_MY_ACCOUNT;

define('MyA_AJAX_ACTUALITE', true);
define('MyA_ENVIRONNEMENT', true);
define('MyA_VERSIONNING', true);
define('MyA_ACTIVE_IMPORTS', true);
define('MyA_ACTIVE_NEW_COOKIES', true);
define('MyA_ACTIVE_PASSLOST', true);

define('MyA_URL', 'index.php?name='.$module_name );
define('MyA_GESTION', 'modules/MyAccount/gestion/' );
define('MyA_PUBLIC', 'modules/MyAccount/public/' );

//if ( defined('USER_ALLOW') AND empty( $op ) ) { $op = 'userinfo'; }
if ( !is_file( INCLUDE_PATH.''.CACHE.'/Configuration/'.PREFIX_CACHE.'_cache_config_website.php' ) )
	Minimus_get_config( 1 );

function chmods_recurse($path) {
	if ( Chmods_Importation == 0 ) return;
	if ( Chmods_Importation != 0 and Chmods_Importation != 0644 and Chmods_Importation != 0754 and Chmods_Importation != 0755 and Chmods_Importation != 0774 and Chmods_Importation != 0775 and Chmods_Importation != 0777 ) return;
	$path= rtrim($path, '/').'/';
	$handle = opendir($path);
	for (;false !== ($file = readdir($handle));)
		if($file != '.' and $file != '..' ) {
		$fullpath= $path.$file;
		if( is_dir($fullpath) ) {
			chmods_recurse($fullpath);
			chmod( $fullpath, Chmods_Importation );
		} else {
			chmod( $fullpath, Chmods_Importation );
		}
	}
	closedir($handle);
}

function rmdir_recurse($path) {
	$path= rtrim($path, '/').'/';
	$handle = opendir($path);
	for (;false !== ($file = readdir($handle));)
		if($file != '.' and $file != '..' ) {
		$fullpath= $path.$file;
		if( is_dir($fullpath) ) {
			rmdir_recurse($fullpath);
			rmdir($fullpath);
			echo 'Suppression du dossier '.$fullpath.' ' ;
			( is_dir( $fullpath ) ) ? $test = '<font color="red">chou</font>' : $test = '<font color="green">russi</font>';
			echo $test.'<br/>';
		} else {
			echo 'Suppression du fichier '.$fullpath.' ' ;
			unlink($fullpath);
			( is_file( $fullpath ) ) ? $test = '<font color="red">chou</font>' : $test = '<font color="green">russi</font>';
			echo $test.'<br/>';
		}
	}
	closedir($handle);
}

FUNCTION h( $nb, $str, $class=false, $id=false ) {
	$nb    = secure( $nb, 'num');
	$str   = secure( $str, 'strip', '', '' );
	$class = secure( $class, '', 'clean', 'sec' );
	empty( $class ) ? $ext = '' : $ext = " class='$class'";
	empty( $id ) ? $extid = '' : $extid = " id='$id'";
	echo "<h$nb$ext$extid>".$str."</h$nb>\n";
}

FUNCTION barre( $pr ) {
	$a = $pr*10;
	( $a == 100 ) ? $b = 0 : $b = 100-$pr*10;
	echo "<table border=\"0\" cellpadding=\"2\" cellspacing=\"0\" style=\"border:1px solid
	#000000;height:10px;width:500px;\">
			<tr><td align='center' style='font-size:12px;color:white;font-weight:bold;background-color:#339900;width:".$a."px'> $a % </td>";
	if($pr<10) {
		echo "<td style=\"width:".$b."px\"></td>";
	}
	echo '</tr></table>';
	br(2);

}


FUNCTION Menu( $id=false ) {
	global $cookie, $userinfo,$admin;
	if (!is_array($admin)) {
			$admin = strip_tags( $admin );
			$admin = base64_decode($admin);
			$admin = addslashes($admin);
			$admin = explode(':', $admin);
	}
	echo '<ul id="menu_myaccount">';
	if ( secure( $userinfo['adjoint'], 'num') == 1 ) {
		if (isset($admin) && @intval($admin[0]) == 1 && $admin[1] == COOKIE_ADMIN_KEY ) {
			echo '<li><a href="'.MyA_URL.'&amp;op=admin&amp;mode=0">'._MA_PUSH_USER.'</a></li>';
		} else {
			echo '<li><a href="'.MyA_URL.'&amp;op=admin&amp;mode=1">'._MA_PUSH_ADMIN.'</a></li>';
		}
	}
	echo '<li><a href="'.MyA_URL.'&amp;op=userinfo">'._MA_MY_INFOS.'</a></li>'
	    .'<li><a href="'.MyA_URL.'&amp;op=userinfo_modif">'._MA_MY_INFOS_MODIF.'</a></li>'
	    .'<li><a href="'.MyA_URL.'&amp;op=logout">'._MA_LOGOUT.'</a></li>'
	    .'</ul>';

	if ( defined('ADMIN_ALLOW') ) {
		$sel1 = $sel2 = $sel3 = $sel4 = $sel5 = $sel6 = '';
		switch( $id ) {
			case 1 : $sel1 = ' id="my_admin_active"'; break;
			case 2 : $sel2 = ' id="my_admin_active"'; break;
			case 3 : $sel3 = ' id="my_admin_active"'; break;
			case 4 : $sel4 = ' id="my_admin_active"'; break;
			case 5 : $sel5 = ' id="my_admin_active"'; break;
			case 6 : $sel6 = ' id="my_admin_active"'; break;
		}
		echo '<div style="padding:2px"></div><ul id="menu_myaccount_admin">'
		    .'<li><a href="'.MyA_URL.'&amp;op=config_website"><span'.$sel1.'>'._MA_CONFIG_WEBSITE.'</span></a></li>'
		    .'<li><a href="'.MyA_URL.'&amp;op=config_menu"><span'.$sel2.'>'._MA_MENU.'</span></a></li>'
		    .'<li><a href="'.MyA_URL.'&amp;op=config_template"><span'.$sel3.'>'._MA_TEMPLATE.'</span></a></li>'
		    .'<li><a href="'.MyA_URL.'&amp;op=config_database"><span'.$sel4.'>'._MA_DATABASE.'</span></a></li>'
		    .'<li><a href="'.MyA_URL.'&amp;op=config_users"><span'.$sel5.'>'._MA_USERS.'</span></a></li>';
		if ( MyA_ACTIVE_IMPORTS === true )
		    	echo '<li><a href="'.MyA_URL.'&amp;op=config_minimus"><span'.$sel6.'>'._MA_SOFTWARE.'</span></a></li>';
		echo '</ul>';
	}
}


if ( defined('ADMIN_ALLOW') ) {
	switch( $op ) {
		case 'config_backup':include_once(MyA_GESTION.'config_backup.php');break;
		case 'config_database':include_once(MyA_GESTION.'config_database.php');break;
		case 'config_menu':include_once(MyA_GESTION.'config_menu.php');break;
		case 'config_minimus':include_once(MyA_GESTION.'config_minimus.php');break;
		case 'config_template':include_once(MyA_GESTION.'config_template.php');break;
		case 'config_users':include_once(MyA_GESTION.'config_users.php');break;
		case 'config_website':include_once(MyA_GESTION.'config_website.php');break;
		case 'config_website_save':include_once(MyA_GESTION.'config_website_save.php');break;
		case 'Delete_folder':include_once(MyA_GESTION.'Delete_folder.php');break;
		case 'Import_Module':include_once(MyA_GESTION.'Import_Module.php');break;
		case 'Import_Theme':include_once(MyA_GESTION.'Import_Theme.php');break;
	}
}

switch( $op ) {
	case 'activate':include_once(MyA_PUBLIC.'activate.php');break;
	case 'admin':
		if ( defined('USER_ALLOW') ) {
			if ( secure( $userinfo['adjoint'], 'num') == 1 ) {
				if ( $mode == 1 ) {
				$info = base64_encode('1:'.COOKIE_ADMIN_KEY);
					@setcookie('admin', $info , time()+31536000 );
				} else {
					@setcookie('admin', false);
				}
			}
		}
		redirect_url( MyA_URL );
	break;
	case 'create':include_once(MyA_PUBLIC.'create.php');break;
	case 'del_cookies':
		Control_Access( 'Come back see an other page ...');
		incoh();
		@setcookie('user');
		@setcookie('admin');
		if ( is_module('Fluxbb') ) @setcookie('forum_cookie');
		br(1);
		echo '<fieldset><legend> <strong>'._MA_DELCOOKIES.'</strong></legend>';
		echo '<div style="padding:20px;text-align:center">'._MA_DELCOOKIES2.'</div>';
		echo '</fieldset>';
		br(3);
		echo "<meta http-equiv=\"refresh\" content=\"3;url=".MyA_URL."\">"
		."<meta http-equiv=\"Pragma\" content=\"no-cache\">";
		incof();
	break;
	case 'create_it':include_once(MyA_PUBLIC.'create_it.php');break;
	case 'login':include_once(MyA_PUBLIC.'login.php');break;
	case 'passlost':include_once(MyA_PUBLIC.'passlost.php');break;
	case 'userinfo':include_once(MyA_PUBLIC.'userinfo.php');break;
	case 'userinfo_modif':include_once(MyA_PUBLIC.'userinfo_modif.php');break;
	case 'logout':
		if ( defined('USER_ALLOW') ) {
			Control_Access( 'Come back see an other page ...');
			$cookie[1] = secure( $cookie[1], '', 'hard', 'xss');
        		$GLOBALS['db']->query("DELETE FROM `".TABLE_SESSION."` WHERE `uname`='".$cookie[1]."'");
			op_database::optimize( TABLE_SESSION );
			@setcookie('user', false);
			@setcookie('admin', false);
			if ( is_module('Fluxbb') ) @setcookie('forum_cookie', false);
			@session_destroy();
			Kill_Sessions();
		}
		redirect_url( MyA_URL );
	break;

	default:include_once(MyA_PUBLIC.'index.php');break;

}