      function fadeColors(id,startColor,stopColor,nbTrans,delay) {
          var elm = document.getElementById(id) || document.getElementById("fadingDiv" );
          var delay = delay || 100;
          var nbTrans = nbTrans || 20;
          var startColor = startColor || [255,255,255];
          var stopColor = stopColor || [99,0,0];
          var rDelta = Math.floor((stopColor[0]-startColor[0])/nbTrans);
          var gDelta = Math.floor((stopColor[1]-startColor[1])/nbTrans);
          var bDelta = Math.floor((stopColor[2]-startColor[2])/nbTrans);
          var rTemp = startColor[0];
          var gTemp = startColor[1];
          var bTemp = startColor[2];
          var interval = setInterval(function() {
              rTemp += rDelta;
              gTemp += gDelta;
              bTemp += bDelta;
	  if ( elm != null ) {
              elm.style.backgroundColor = "rgb("+rTemp+","+gTemp+","+bTemp+" )";
              if (rTemp<0 || gTemp<0 || bTemp<0|| rTemp>255 || gTemp>255 || bTemp>255 ) {
                  clearInterval(interval);
                  elm.style.backgroundColor = "rgb("+stopColor[0]+","+stopColor[1]+","+stopColor[2]+" )";;
              }
	  }
          },delay);

      }

      onload = function() {
          fadeColors();
          fadeColors("fadingDiv2",[46,241,32],[255,32,28]);
          fadeColors("succesDiv",[145,186,2], [235,255,167], 15, 50);
          fadeColors("errorDiv",[187,0,0], [255,238,221], 15, 50);
          fadeColors("blueDiv",[2,6,180], [239,239,255], 15, 50);
      };
