<?php
/************************************************************************/
/* Minimus Blog: Web Portal System                                      */
/* ===============================                                      */
/* Write by Cyril Levert                                                */
/* Copyright (c) 2009-2010                                              */
/* http://www.php-minimus.org                                           */
/* dev@php-minimus.org                                                  */
/*                                                                      */
/* This program is free software.                                       */
/************************************************************************/
/* Based on PHP-Maximus: Web Portal System                              */
/************************************************************************/
defined('MINIMUS') or die ('Access denied meta MINIMUS directly...');

global $urlsite, $sitename, $slogan, $adminmail;

echo '<meta http-equiv="content-type" content="text/html; charset='._CHARSET.'" />'."\n";
echo '<meta http-equiv="content-script-type" content="text/javascript" />'."\n";
echo '<meta http-equiv="content-style-type" content="text/css" />'."\n";
echo '<meta http-equiv="expires" content="0" />'."\n";
echo '<meta http-equiv="pragma" content="no-cache" />'."\n";
echo '<meta http-equiv="identifier-url" content="http://'.$urlsite.'" />'."\n";
echo '<meta name="resource-type" content="document" />'."\n";
echo '<meta name="distribution" content="global" />'."\n";
echo '<meta name="author" content="'.$sitename.'" />'."\n";
echo '<meta name="copyright" content="Copyright (c) by '.$sitename.'" />'."\n";
echo '<meta name="owner" content="www.php-minimus.org" />'."\n";
echo '<meta name="reply-to" content="'.$adminmail.'" />'."\n";
echo '<meta name="language" content="fr" />'."\n";
echo '<meta http-equiv="content-language" content="fr, fr-be, fr-ca, fr-lu, fr-ch, it-it, es-es, en-en" />'."\n";
echo '<meta name="Publisher" content="Cyril Levert" />'."\n";
echo '<meta name="Date-Creation-yyyymmdd" content="20091101" />'."\n";

$today = getdate();
$day   = intval($today['mday']);
if ($day < 10) $day = '0'.$day;
$month = intval($today['mon']);
if ($month < 10) $month = '0'.$month;
$year  = intval($today['year']);
echo '<meta name="Date-Revision-yyyymmdd" content="'.$year.''.$month.''.$day.'" />'."\n";

( defined('META_KEYWORDS') ) ? $metakeys =  META_KEYWORDS.', ' : $metakeys = '';
( defined('META_DESCRIPTION') ) ? $metadesc = META_DESCRIPTION.' ' : $metadesc = '';
echo '<meta name="description" content="'.$metadesc.''.$slogan.'" />'."\n"
	.'<meta name="abstract" content="'.$metadesc.''.$slogan.'" />'."\n"
	.'<meta name="keywords" content="'.$metakeys.'Minimus, minimus, Maximus, maximus, Blog, blog, CMS, cms, Communaute, communaute, Billet, billet, Articles, articles, Publication, publication, News, news, Modules, modules, Scripts, scripts, France, france, Francais, francais, Francophone, franchophone, PHP, php, Kernel, kernel" />'."\n";

echo '<meta name="generator" content="PHP Minimus CMS - Copyright by http://www.php-minimus.org. This is a free software, and you may redistibute it under the Minimus Licence(http://www.php-minimus.org/blog_minimus_licence-1.html. PHP Minimus come with absolutely no warrantly, for details, see the licence" />'."\n";

echo '<meta name="robots" content="index, follow" />'."\n"
	.'<meta name="revisit-after" content="1 days" />'."\n"
	.'<meta name="rating" content="general" />'."\n"
	.'<!-- Powered by PHP Minimus CMS -->'."\n";
