<?php
/************************************************************************/
/* Minimus Blog: Web Portal System                                      */
/* ===============================                                      */
/* Write by Cyril Levert                                                */
/* Copyright (c) 2009-2010                                              */
/* http://www.php-minimus.org                                           */
/* dev@php-minimus.org                                                  */
/*                                                                      */
/* This program is free software.                                       */
/************************************************************************/
/* Based on PHP-Maximus: Web Portal System                              */
/************************************************************************/
defined('MAXIMUS') or die('Acces formulaires denied');

Class Form {

	PUBLIC	FUNCTION Debut_DT( $link, $class=false, $plus=false ) {
		!empty( $class ) ? $id = ' class="'.$class.'"' : $id = '';
		!empty( $plus ) ? $push = $plus : $push = '';
		echo "<form method=\"post\" action=\"$link\" $id $push>
		<dl>\n";
	}

	PUBLIC	FUNCTION Fin_DT( $text, $index ) {
		echo '<dt>&nbsp;</dt>
		<dd><input tabindex="'.$index.'" type="submit" title="'.$text.'" value="'.$text.'" />
		</dd>';
	}

	PUBLIC	FUNCTION Close_DT( $value ) {
		echo '<dd><input type="hidden" name="op" value="'.$value.'" />
			<input type="hidden" name="valid" value="1" /></dd></dl>
			</form>';
	}

	PUBLIC	FUNCTION Close_DT_Create( $value ) {
		echo '<dd><input type="hidden" name="op" value="'.$value.'" />
			<input type="hidden" name="create" value="1" /></dd></dl>
			</form>';
	}

	PUBLIC	FUNCTION Input_Code_DT() {
		echo '<dt><strong>'._SECURITYCODE.'</strong></dt>' ;
		echo '<dd>';
		code_accessibilite();
		echo " <input tabindex='3' id='securitycode' type='text' name='gfx_check' /></dd>";
	}

	PUBLIC	FUNCTION Input_DT( $text, $nam, $label, $valeur, $index, $disabled=false, $type=false) {
		( !empty( $disabled ) ) ? $dis = ' disabled="disabled"' : $dis = '';
		( !empty( $type ) ) ? $tp = 'password' : $tp = 'text';
		echo '<dt><label title="'.strip_tags( $text ).'" for="'.$label.'">'.$text.'</label></dt>
		<dd><input'.$dis.' tabindex="'.$index.'" id="'.$label.'" type="'.$tp.'" name="x'.$nam.'" value="'.$valeur.'" title="'.strip_tags( $text ).'" /></dd>'."\n";
	}
	PUBLIC	FUNCTION Input_Pass_DT( $text, $nam, $label, $valeur, $index) {
		echo '<dt><label title="'.strip_tags( $text ).'" for="'.$label.'">'.$text.'</label></dt>
		<dd><input tabindex="'.$index.'" id="'.$label.'" type="password" name="x'.$nam.'" value="'.$valeur.'" /></dd>'."\n";
	}
	PUBLIC	FUNCTION Input_hidden_DT( $nam, $valeur ) {
		echo '<dd><input type="hidden" name="'.$nam.'" value="'.$valeur.'" /></dd>';
	}
	PUBLIC	FUNCTION Select_Language_DT( $text, $valeur ) {
		echo '<dt><label title="'.strip_tags( $text ).'" for="language">'.$text.'</label></dt>';
		$handle=opendir('language'); $languageslist = '';
		while ($file = readdir($handle)) {
			if (ereg("^lang\-(.+)\.php", $file, $matches)) {
				$langFound = $matches[1];
				$languageslist .= "$langFound ";
			}
		}
		closedir($handle);
		$languageslist = explode(' ', $languageslist);
		sort($languageslist);
		echo '<dd><select name="xlanguage">';
		for ($i=0; $i < sizeof($languageslist); $i++) {
			if( !empty( $languageslist[$i] ) ) {
				echo '<option value="'.$languageslist[$i].'"';
				if ( $languageslist[$i] == $valeur ) echo ' selected="selected"';
				echo '>'.ucfirst($languageslist[$i]).'</option>'."\n";
			}
		}
		echo '</select></dd>'."\n";
	}
	PUBLIC	FUNCTION Select_Multiple_DT( $text, $nam, $label, $valeur ) {
		echo '<dt><label title="'.strip_tags( $text ).'" for="'.$label.'">'.$text.'</label></dt>';
		$themelist = '';
		$handle = opendir( $nam );
		while ($file = readdir($handle)) {
			if ( (!ereg("[.]",$file)) ) {
				$themelist .= "$file ";
			}
		}
		closedir($handle);
		$themelist = explode(' ', $themelist);
		sort($themelist);

		echo '<dd><select name="x'.$nam.'">';
		for ($i=0; $i < sizeof($themelist); $i++) {
			if( !empty( $themelist[$i] ) ) {
				( $themelist[$i] == $valeur ) ? $sel = ' selected="selected"' : $sel = '';
				echo '<option value='.$themelist[$i].' '.$sel.'>'.$themelist[$i].'</option>';
			}
		}
		echo '</select></dd>'."\n";
	}

	PUBLIC	FUNCTION Select_Locale_DT( $text, $label, $valeur ) {
		echo '<dt><label title="'.strip_tags( $text ).'" for="'.$label.'">'.$text.'</label></dt>';
		$lang = array('en_EN', 'es_ES', 'fr_FR', 'it_IT');
		sort($lang);
		echo '<dd><select name="xlocale">';
		foreach($lang as $valor){
			( $valor == $valeur ) ? $sel = ' selected="selected"' : $sel = '';
			echo '<option value='.$valor.' '.$sel.'>'.$valor.'</option>';
		}
		echo '</select></dd>'."\n";
	}

	PUBLIC	FUNCTION Select_Decalage_DT( $text, $label, $valeur ) {
		echo '<dt><label title="'.strip_tags( $text ).'" for="'.$label.'">'.$text.'</label></dt>';
		echo '<dd><select name="xdecalage">';
		for ($i=-24; $i < 24; $i++) {
			( $i == $valeur ) ? $sel = ' selected="selected"' : $sel = '';
			echo '<option value='.$i.' '.$sel.'>'.$i.'</option>';
		}
		echo '</select></dd>'."\n";
	}

	PUBLIC	FUNCTION Select_Editeur_HTML_DT( $text, $label, $valeur ) {
		echo '<dt><label title="'.strip_tags( $text ).'" for="'.$label.'">'.$text.'</label></dt>';
		echo '<dd><select name="xediteur">';
		$sel0 = $sel1 = $sel2 = $sel3 = $sel4 = '';
		if ( empty( $valeur ) ) $sel0 = ' selected="selected"';
		echo "<option value=''$sel0>"._MA_EDITEUR_NO."</option>";
		if ( $valeur == 'nicedit' ) $sel1 = ' selected="selected"';
		echo "<option value='nicedit'$sel1>"._MA_EDITEUR_NICEDIT."</option>";
		if ( $valeur == 'fckeditor' ) $sel2 = ' selected="selected"';
		if ( is_dir('FCKeditor') )
			echo "<option value='fckeditor'$sel2>"._MA_EDITEUR_FCKEDITOR."</option>";
		if ( $valeur == 'ckeditor' ) $sel3 = ' selected="selected"';
		if ( is_dir('ckeditor') )
			echo "<option value='ckeditor'$sel3>"._MA_EDITEUR_CKEDITOR."</option>";
		echo '</select></dd>'."\n";
	}
	PUBLIC	FUNCTION Radio_Edit_DT ( $var, $field, $title ) {
		if ( $var == 1) {
			$ck1 = " checked='checked'"; $ck2 = ''; $color = 'green'; $color1 = 'black';
		} else {
			$ck1 = ''; $ck2 = " checked='checked'"; $color = 'black'; $color1 = 'red';
		}
		echo "<dt><label title=\"".strip_tags( $title )."\"> $title </label></dt><dd>"
   	  	    ."<input id='x".$field."Y' type='radio' name='x".$field."' value='1' $ck1 /><label for='x".$field."Y' 	title='"._YES."'><font color='$color'>"._YES." </font></label>&nbsp;"
   	   	    ."<input id='x".$field."N' type='radio' name='x".$field."' value='0' $ck2 /><label for='x".$field."N' title='"._NO."'><font color='$color1'>"._NO."</font></label></dd>\n";
	}

	PUBLIC FUNCTION Debut( $link, $class=false ) {
		!empty( $class ) ? $id = ' class="'.$class.'"' : $id = '';
		echo "<form action='$link' method='post'$id>\n";
	}

	PUBLIC	FUNCTION Input_BR( $nom, $nam, $valeur, $size ) {
		echo $nom.' <input type="text" name="'.$nam.'" value="'.$valeur.'" size="'.$size.'" />';
		br(2);
	}
	PUBLIC	FUNCTION Input( $nom, $nam, $valeur ) {
		echo '<tr><td>'.$nom.'</td><td><input type="text" name="x'.$nam.'" value="'.$valeur.'" size="60" /></td></tr>'."\n";
	}
	FUNCTION Input_hidden( $nam, $valeur ) {
		echo '<input type="hidden" name="'.$nam.'" value="'.$valeur.'" />';
	}

	PUBLIC	FUNCTION Textarea ( $var, $value, $title, $rows=false, $cols=false, $class=false) {
		empty( $rows ) ? $rows = 5 : '';
		empty( $cols ) ? $cols = 40 : '';
		echo $title."<br/><textarea class='".$class."' name='".$value."' rows='$rows' cols='$cols'>$var</textarea><br />\n";
	}
	PUBLIC	FUNCTION Fin( $value, $text ) {
		echo "<input type='hidden' name='op' value='$value' />
                      <input class='submit' type='submit' value='$text' /></form>\n";
	}

}
