<?php
/************************************************************************/
/* Minimus Blog: Web Portal System                                      */
/* ===============================                                      */
/* Write by Cyril Levert                                                */
/* Copyright (c) 2009-2010                                              */
/* http://www.php-minimus.org                                           */
/* dev@php-minimus.org                                                  */
/*                                                                      */
/* This program is free software.                                       */
/************************************************************************/
/* Based on PHP-Maximus: Web Portal System                              */
/************************************************************************/
defined('MINIMUS') OR die ('Access denied config_template.php');
if ( ! defined('ADMIN_ALLOW') ) redirect_url( MyA_URL );

define('TRANSITION_JS', true);

isset($install) ? $install = secure( $install, '', '', 'clean' ) : $install = '';
isset($remove) ? $remove = secure( $remove, '', '', 'clean' ) : $remove = '';
isset($th) ? $th = secure( $th, '', '', 'clean' ) : $th = '';

incoh();

Menu(6);
br(1);

h( 3, _MA_IMPORT_NEW_FUNCTIONS, 'titre');

if ( $install == 'module' ) div_succes( _MA_MODULE_DISPO.' : '.$th);
if ( $install == 'theme' ) div_succes( _MA_THEME_DISPO.' : '.$th);

if ( $remove == 'modules' ) div_succes( _MA_MODULE_DELETE.' : '.$th);
if ( $remove == 'themes' ) div_succes( _MA_THEME_DELETE.' : '.$th);

echo '<fieldset style="width:85%;margin:auto"><legend>'._MA_IMPORT_NEW_THEMES.'</legend>';
if ( is_writable('themes') ) {
	echo "<form action=\"".MyA_URL."\" method=\"post\">"
	._MA_THEME_MARQUEUR."  &nbsp;<input style='font-weight:bold;margin-left:50px;width:40%' type='text' name='url' value=''/> "
	."<input type='hidden' name='op' value='Import_Theme' />"
	."&nbsp;&nbsp;<input onclick=\"return window.confirm('"._MA_SUR_IMPORT_THEME."');\" type=\"submit\" value=\""._MA_IMPORT."\" /></form>";
} else {
	div_error( _MA_CHMOD_THEME );
}
echo '</fieldset>';

br(1);
echo '<fieldset style="width:85%;margin:auto"><legend>'._MA_IMPORT_NEW_MODULES.'</legend>';
if ( is_writable('modules') ) {
	echo "<form action=\"".MyA_URL."\" method=\"post\">"
	._MA_MODULE_MARQUEUR." &nbsp;<input style='font-weight:bold;margin-left:40px;width:40%' type='text' name='url' value=''/> "
	."<input type='hidden' name='op' value='Import_Module' />"
	."&nbsp;&nbsp;<input onclick=\"return window.confirm('"._MA_SUR_IMPORT_MODULE."');\" type=\"submit\" value=\""._MA_IMPORT."\" /></form>";
} else {
	div_error( _MA_CHMOD_MODULE );
}
echo '</fieldset>';

br(1);
echo '<fieldset style="width:85%;margin:auto"><legend>'._MA_IMPORT_NEW_KERNEL.'</legend>';
if ( is_writable('/') ) {
	echo "<form action=\"".MyA_URL."\" method=\"post\">"
	._MA_KERNEL_MARQUEUR." &nbsp;<input style='font-weight:bold;margin-left:10px;width:40%' type='text' name='url' value=''/> "
	."<input type='hidden' name='op' value='Import_Update' />"
	."&nbsp;&nbsp;<input onclick=\"return window.confirm('"._MA_SUR_IMPORT_KERNEL."');\" type=\"submit\" value=\""._MA_IMPORT."\" /></form>";
} else {
	div_error( _MA_CHMOD_KERNEL );
}
echo '</fieldset>';

br(1);
h( 3,_MA_DELETE_IMPORTS, 'titre');

echo '<fieldset style="width:85%;margin:auto"><legend>'._MA_DELETE_THEMES.'</legend>';
echo "<div class='box_img_col_right'><form action=\"".MyA_URL."\" method=\"post\">"
._MA_DELETE_THEMES_OK." &nbsp;";
echo "<select name=\"xthemes\">";
	$themelist = '';
	$handle = opendir('themes');
	while ($file = readdir($handle)) {
		if ( (!ereg("[.]",$file)) )
			$themelist .= "$file ";
	}
	closedir($handle);
	$themelist = explode(' ', $themelist);
	sort($themelist);
	for ($i=0; $i < sizeof($themelist); $i++) {
		if( !empty( $themelist[$i] ) and is_writable('themes/'.$themelist[$i] ) and $themelist[$i] != $Default_Theme )
			echo "<option value=\"".$themelist[$i]."\">".$themelist[$i]."</option>\n";
	}
	echo "</select>";

echo "<input type='hidden' name='op' value='Delete_folder' />"
."<input type='hidden' name='type' value='themes' />"
."&nbsp;&nbsp;<input type=\"submit\" onclick=\"return window.confirm('"._MA_SUR_DELETE_THEME."');\" value=\""._MA_DELETE_THEME_IT."\" /></form></div></fieldset>";

br( 1 );
echo '<fieldset style="width:85%;margin:auto"><legend>'._MA_DELETE_MODULES.'</legend>';
echo "<div class='box_img_col_right'><form action=\"".MyA_URL."\" method=\"post\">"
._MA_DELETE_MODULES_OK." &nbsp;";
echo "<select name=\"xmodules\">";
	$themelist = '';
	$handle = opendir('modules');
	while ($file = readdir($handle)) {
		if ( (!ereg("[.]",$file)) )
			$themelist .= "$file ";
	}
	closedir($handle);
	$themelist = explode(' ', $themelist);
	sort($themelist);
	for ($i=0; $i < sizeof($themelist); $i++) {
		if( !empty( $themelist[$i] ) and ($themelist[$i] != 'Blogs' )  and ($themelist[$i] != 'Copyrights' )  and ($themelist[$i] != 'Tags' )  and ($themelist[$i] != 'MyAccount' ) and is_writable('modules/'.$themelist[$i] ) )
			echo "<option value=\"".$themelist[$i]."\">".$themelist[$i]."</option>\n";
	}
	echo "</select>";

echo "<input type='hidden' name='type' value='modules' />"
."<input type='hidden' name='op' value='Delete_folder' />"
."&nbsp;&nbsp;<input onclick=\"return window.confirm('"._MA_SUR_DELETE_MODULE."');\" type=\"submit\" value=\""._MA_DELETE_MODULES_IT."\" /></form></div></fieldset>";


incof();