<?php
/************************************************************************/
/* Minimus Blog: Web Portal System                                      */
/* ===============================                                      */
/* Write by Cyril Levert                                                */
/* Copyright (c) 2009-2010                                              */
/* http://www.php-minimus.org                                           */
/* dev@php-minimus.org                                                  */
/*                                                                      */
/* This program is free software.                                       */
/************************************************************************/
/* Based on PHP-Maximus: Web Portal System                              */
/************************************************************************/
defined('MINIMUS') OR die ('Access denied config_template.php');
if ( ! defined('ADMIN_ALLOW') ) redirect_url( MyA_URL );

define('TRANSITION_JS', true);
isset($type) ? $type = secure( $type, '', '', 'clean' ) : $type = '';
isset($template) ? $template = secure( $template, '', '', 'clean' ) : $template = '';
isset($th) ? $th = secure( $th, '', '', 'clean' ) : $th = '';
isset($install) ? $install = secure( $install, '', '', 'clean' ) : $install = '';

define('CREATE_TABS', 'webfx');

incoh();
Menu(3);
br(1);
$a=0;


if ( $install == 1 ) div_succes( _MA_NEW_THEME_OK.': '.$th);
if ( $install == 2 ) div_error( _MA_NEW_THEME_NO.': '.$th);

if ( !empty( $template ) ) $theme = $_SESSION['move_template'] = $template;
if ( !empty( $_SESSION['move_template'] ) ) $theme = $_SESSION['move_template'];

if ( empty( $theme ) ) $theme = $ThemeSel ;


if ( !empty( $th ) ) $theme = $_SESSION['move_template'] = $template = $th;

$themelist = '';
$handle = opendir('themes');
while ($file = readdir($handle)) {
	if ( (!ereg("[.]",$file)) ) {
		$themelist .= "$file ";
	}
}
closedir($handle);
$themelist = explode(' ', $themelist);
sort($themelist);
echo '<form action="" method="post">';
$url= MyA_URL.'&amp;op=config_template&amp;template=';
echo _MA_TEMPLATE.' : <select name="template" onchange="top.location.href=this.options[this.selectedIndex].value">';
for ($i=0; $i < sizeof($themelist); $i++) {
	if( !empty( $themelist[$i] ) ) {
	if ( empty( $_SESSION['move_template'] ) ) {
		( $themelist[$i] == $ThemeSel ) ? $sel = ' selected="selected"' : $sel = '';
	} else {
		( $themelist[$i] == $theme ) ? $sel = ' selected="selected"' : $sel = '';
	}
	echo '<option value='.$url.''.$themelist[$i].' '.$sel.'>'.$themelist[$i].'</option>';
	}
}
echo '</select>';
echo '</form>';
br(1);

if ( ! is_writeable(INCLUDE_PATH.'themes/') ) {
	div_error( _MA_CHMODS_FOLDER_THEMES );$a++;
}
if ( ! is_writeable(INCLUDE_PATH.'themes/'.$theme.'/') ) {
	div_error( _MA_CHMODS_FOLDER_THEMES2.' themes/'.$theme.'/' );$a++;
}
if ( ! is_writeable(INCLUDE_PATH.'themes/'.$theme.'/style.css') ) {
	div_error( _MA_CHMODS_FILE_CSS_THEMES.' themes/'.$theme.'/style.css' );$a++;
}
if ( ! is_writeable(INCLUDE_PATH.'themes/'.$theme.'/header.html') ) {
	div_error( _MA_CHMODS_FILE_HEADER_THEMES.' themes/'.$theme.'/header.html' );$a++;
}
if ( ! is_writeable(INCLUDE_PATH.'themes/'.$theme.'/footer.html') ) {
	div_error( _MA_CHMODS_FILE_FOOTER_THEMES.' themes/'.$theme.'/footer.html' );$a++;
}

if ( !empty( $a ) ) { br(1); incof(); }

if ( $type == 'ok' ) {
	$xmenu = trim( $xmenu );

	if ( empty( $xmenu ) ) {
		copy( INCLUDE_PATH.'themes/'.$theme.'/'.$fichier,  INCLUDE_PATH.'themes/'.$theme.'/old-'.$fichier );
		unlink( INCLUDE_PATH.'themes/'.$theme.'/'.$fichier );
	} else {
		if ( $fichier != 'kernel' ) {
			copy( INCLUDE_PATH.'themes/'.$theme.'/'.$fichier,  INCLUDE_PATH.'themes/'.$theme.'/old-'.$fichier  );
			$file1 = @fopen( INCLUDE_PATH.'themes/'.$theme.'/'.$fichier, 'wb');
		} else {
			copy( INCLUDE_PATH.'kernel/style.css',  INCLUDE_PATH.'kernel/style.css' );
			$file1 = @fopen( INCLUDE_PATH.'kernel/style.css', 'wb');
		}
		if (!$file1)
			die('Unable to write file to themes directory. Please make sure PHP has write access to the directory \'themes/\'');
		@fwrite($file1, stripslashes( $xmenu ) );
		@fclose($file1);
	}
	div_succes( _MA_FILE.' '.$file.' '._MA_FILE_REGISTRED);
}

$currentTabs=new Tabs('headers');
$currentTabs->StartTabWindow();
$currentTabs->AddTab( _MA_TABS_TOP );

$tmp = 'modules/MyAccount/class/formulaires.php';
if ( is_file( $tmp ) ) include_once( $tmp );

	$form = new Form();

	$content = '';
	$tmp = INCLUDE_PATH.'themes/'.$theme.'/header.html';
	if ( is_file( $tmp ) ) $content = stripslashes( file_get_contents( $tmp ) );

	$form->Debut_DT( MyA_URL, 'bigtextarea');
	$form->Textarea( $content, 'xmenu', _MA_CONFIG_HEADER);
	$form->Input_hidden( 'theme', $theme );
	$form->Input_hidden( 'type', 'ok' );
	$form->Input_hidden( 'fichier', 'header.html' );
	$form->Fin_DT( _MA_VALIDER , 23 );
	$form->Close_DT( 'config_template' );

$currentTabs->AddTab( _MA_TABS_BOTTOM );

	$content = '';
	$tmp = INCLUDE_PATH.'themes/'.$theme.'/footer.html';
	if ( is_file( $tmp ) ) $content = stripslashes( file_get_contents( $tmp ) );

	$form->Debut( MyA_URL, 'bigtextarea' );
	$form->Textarea( $content, 'xmenu', _MA_CONFIG_FOOTER);
	$form->Input_hidden( 'theme', $theme );
	$form->Input_hidden( 'type', 'ok' );
	$form->Input_hidden( 'fichier', 'footer.html' );
	$form->Fin_DT( _MA_VALIDER , 2 );
	$form->Close_DT( 'config_template' );

$currentTabs->AddTab( _MA_TABS_CSS );

	$content = '';
	$tmp = INCLUDE_PATH.'themes/'.$theme.'/style.css';
	if ( is_file( $tmp ) ) $content = stripslashes( file_get_contents( $tmp ) );

	$form->Debut( MyA_URL, 'bigtextarea' );
	$form->Textarea( $content, 'xmenu', _MA_CONFIG_CSS);
	$form->Input_hidden( 'theme', $theme );
	$form->Input_hidden( 'type', 'ok' );
	$form->Input_hidden( 'fichier', 'style.css' );
	$form->Fin_DT( _MA_VALIDER , 2 );
	$form->Close_DT( 'config_template' );

$currentTabs->AddTab( _MA_TABS_CSS_BASE );

	$content = '';
	$tmp = INCLUDE_PATH.'kernel/style.css';
	if ( is_file( $tmp ) ) $content = stripslashes( file_get_contents( $tmp ) );

	$form->Debut( MyA_URL, 'bigtextarea' );
	$form->Textarea( $content, 'xmenu', _MA_CONFIG_CSS);
	$form->Input_hidden( 'type', 'ok' );
	$form->Input_hidden( 'fichier', 'kernel' );
	$form->Fin_DT( _MA_VALIDER , 2 );
	$form->Close_DT( 'config_template' );

$currentTabs->EndTabWindow();

incof();