<?php
/************************************************************************/
/* Minimus Blog: Web Portal System                                      */
/* ===============================                                      */
/* Write by Cyril Levert                                                */
/* Copyright (c) 2009-2010                                              */
/* http://www.php-minimus.org                                           */
/* dev@php-minimus.org                                                  */
/*                                                                      */
/* This program is free software.                                       */
/************************************************************************/
/* Based on PHP-Maximus: Web Portal System                              */
/************************************************************************/
defined('MINIMUS') OR die ('Access denied config_website.php');
if ( ! defined('ADMIN_ALLOW') ) redirect_url(MyA_URL);

define('TRANSITION_JS', true);

incoh();
Menu(1);
br(1);

$tmp = 'modules/MyAccount/class/formulaires.php';
if ( is_file( $tmp ) ) include_once( $tmp );

$form = new Form();

echo '<fieldset><legend>'._MA_CONFIG_WEBSITE.'</legend>';

$form->Debut_DT( MyA_URL, 'Form');
$form->Input_DT( _MA_WEBSITE_NAME, 'sitename', 'sitename', $sitename, 1);
$form->Input_DT( _MA_WEBSITE_URL, 'urlsite', 'urlsite', $urlsite, 2 );
$form->Input_DT( _MA_WEBSITE_SLOGAN, 'slogan', 'slogan', $slogan, 3 );
$form->Input_DT( _MA_WEBSITE_STARTDATE, 'startsite', 'startsite', $config['startsite'], 4 );
$form->Input_DT( _MA_WEBSITE_ADMINMAIL, 'adminmail', 'adminmail', $adminmail, 5 );
$form->Input_DT( _MA_WEBSITE_ANONYMOUS, 'anonymous', 'anonymous', $anonymous, 7 );

$form->Select_Multiple_DT( _MA_WEBSITE_TEMPLATE, 'themes', 'themes', $Default_Theme);
$form->Select_Multiple_DT( _MA_WEBSITE_HOME_MODULE, 'modules', 'modules', $main_module);
$form->Select_Language_DT(_MA_WEBSITE_LANGUAGE, $language );
$form->Select_Locale_DT( _MA_WEBSITE_DATE_HOURS, 'locale', $config['locale'] );
$form->Select_Decalage_DT( _MA_WEBSITE_DECALAGE, 'decalage', $config['decalage'] );
$form->Select_EDITEUR_HTML_DT( _MA_WEBSITE_EDITEUR_HTML, 'editeur', $config['editeur'] );

$form->Radio_Edit_DT ( $rewrite, 'rewrite', _MA_WEBSITE_URL_FRIENDLY );
$form->Radio_Edit_DT ( $config['allow_new_account'], 'allow_new_account', _MA_WEBSITE_ALLOW_NEW_ACCOUNT );
$form->Radio_Edit_DT ( $config['email_new_account'], 'email_new_account', _MA_WEBSITE_CONFIRM_NEW_ACCOUNT );

$form->Fin_DT( _MA_UPDATE_PARAMETRES , 11 );
$form->Close_DT( 'config_website_save' );
echo '</fieldset>';

incof();