<?php
/************************************************************************/
/* PHP Kweeker / Minimus: Web Portal System                             */
/* ========================================                             */
/* Write by Cyril Levert                                                */
/* Copyright (c) 2009 - 2010                                            */
/* PHP Kweeker : http://twitter.php-minimus.org                         */
/* Blog and CMS : http://www.php-minimus.org                            */
/* dev@php-minimus.org                                                  */
/* Write by: Cyril Levert                                               */
/*                                                                      */
/* This program is free software.                                       */
/************************************************************************/
/* Based on PHP-Maximus: Web Portal System                              */
/************************************************************************/
defined('MINIMUS') or Header('Location: ../../index.php');

isset( $id ) ? $id = secure( $id, 'num') : $id = '';
isset( $ok ) ? $ok = secure( $ok, 'bin') : $ok = '';
isset( $respons ) ? $respons = secure( $respons, 'bin') : $respons = '';
isset( $supp ) ? $supp = secure( $supp, 'bin') : $supp = '';
isset( $who ) ? $who = secure( $who, 'strip', 'clean') : $who = '';
isset( $kweek ) ? $kweek = secure( $kweek, '', '', 'xss') : $kweek = '';

define('LIMITE_TEXTAREA_TWITTER', TRUE);


/** Definition des attributs */
define('NB_KWEEKS', get_number_kweeks( $kweek ) );
define('TOTAL_PAGES', ceil( NB_KWEEKS / KWEEKS_BY_PAGE ) );
if( !isset( $page ) ){
	$page_courante = 1;
} else {
	if ( $page < 1 ) {
		$page_courante = 1;
	} elseif ($page > TOTAL_PAGES ) {
		$page_courante = TOTAL_PAGES ;
	} else {
		$page_courante = $page;
	}
}
define('START', ($page_courante * KWEEKS_BY_PAGE - KWEEKS_BY_PAGE ) );

if ( empty( $kweek ) ) {
	define('PAGE_LINK', URL_MODULE );
} else {
	define('PAGE_LINK', URL_MODULE.'&amp;kweek='.$kweek );
}

define('PAGE_LINK', URL_MODULE );
define('ALERTE_SEARCH_TWITTER', true );
define('ALERTE_KWEEK_TWITTER', true );
if ( !empty( $ok ) || !empty( $supp ) ) define('TRANSITION_JS', true);


! defined('KWEEKS_BY_PAGE') ? $kweeks_by_page = 5 : $kweeks_by_page = KWEEKS_BY_PAGE;
! defined('START') ? $start = 0 : $start = START;
if ( $start < 0 ) $start = 0;


$ADD = '';
if ( !empty( $kweek ) ) $ADD = ' AND ( `who`="'.addslashes( $kweek ).'" OR `reponse`="'.addslashes( $kweek ).'" )';

/* last kweek */

$last = $db->get_object("SELECT `tweet` FROM `".TABLE_TWITTER."` WHERE `active` = 1 $ADD ORDER BY `xtime` DESC LIMIT ".$start.", 1");
$last->tweet = bb_kill( secure( $last->tweet, 'strip', 'clean') );

$pagetitle = '';
if ( !empty( $kweek ) ) $pagetitle .= $kweek. ': ';
$pagetitle .= $last->tweet.' - '. _TWITTER_AND_FUN;

define('META_DESCRIPTION', $last->tweet );
define('META_KEYWORDS', str_replace(' ', ',', $last->tweet ) );

if ( empty( $kweek ) ) {
	if ( empty( $page ) ) {
		if ( $main_module != 'Twitter' ) {
			if ( defined('URL_REWRITING') ) {
				define('URL_CANONICAL', '/twitter.html' );
				if ( stristr( URLE, 'op=text' ) ) redirect_url( 'http://'.URL_SITE.''.URL_CANONICAL );
			} else {
				define('URL_CANONICAL', '/index.php?name=Twitter' );
			}
		} else {
			if ( empty( $respons ) ) {
				define('URL_CANONICAL', '' );
				if ( stristr( URLE, 'Twitter' ) ) redirect_url( 'http://'.URL_SITE );
			}
		}
	} else {
		define('URL_CANONICAL', '/index.php?name=Twitter&amp;page='.$page );
	}
} else {
	if ( empty( $page ) ) {
		if ( defined('URL_REWRITING') ) {
			define('URL_CANONICAL', '/twitter-'.$kweek.'.html' );
			if ( stristr( URLE, 'kweek=' ) ) redirect_url( 'http://'.URL_SITE.''.URL_CANONICAL );
		} else {
			define('URL_CANONICAL', '/index.php?name=Twitter&amp;kweek='.$kweek );
		}
	} else {
		define('URL_CANONICAL', '/index.php?name=Twitter&amp;kweek='.$kweek.'&amp;page='.$page );
	}
}

incoh();

echo '<table><tr><td id="full_page">'."\n";

/** en cas de dsactivation */
if ( !empty( $kweek ) ) {
	update_total_user( $kweek );
	$test = $db->get_object("SELECT `active` FROM `".TABLE_TWITTER_ACCOUNT."` WHERE `who` = '$kweek' ");
	if ( $test->active != 1 ) define('ACCOUNT_CLOSED', true );
}
if ( defined('USER_ALLOW') AND ALLOW_KWEEKER === true AND !defined('ACCOUNT_CLOSED') ) {

	br(1);
	!empty( $respons ) ? $new_kweek = '@'.$who.' ' : $new_kweek = '';
	echo '<div id="whats_happening">'."\n";
	if ( !empty( $respons ) )
		echo '&raquo '._YOUR_RESPONSE.' '.$who.' ...';
	else
		echo _WHATS_HAPPENING;

	echo "<span class='size_maxi' id='tweet'>".SIZE_MAXI."</span></div>\n";
	echo '<form action="'.URL_MODULE.'" method="post" name="twitter" onsubmit="return tweettest()">'."\n";
	echo "<textarea tabindex='1' id='first' onkeyup=\"limite(this, ".SIZE_MAXI." );\" onkeydown=\"limite(this, ".SIZE_MAXI.");\" name='tweet'>".$new_kweek."</textarea>\n";
	echo '<input type="hidden" name="op" value="valid" />'."\n";
	if ( !empty( $respons ) )
		echo '<input type="hidden" name="response" value="'.$who.'" />'."\n";
	echo '<input type="submit" value="'._UPDATE.'" title="'._UPDATE.'" tabindex="2" />'."\n";
	echo '</form>';
	br(3);

	if ( !empty( $ok ) ) Div_Succes( _NEW_KWEEK_OK );
	if ( !empty( $supp ) ) Div_Succes( _KWEEK_DELETE_OK );
} else {
	if ( empty( $kweek ) ) echo '<div id="whats_happening">'._LASTS_KWEEKS.'</div>'."\n";
}

if ( !empty( $kweek ) AND !defined('ACCOUNT_CLOSED') )
	echo '<div id="kweek_of">'._KWEEKS_OF.' '.$kweek.'</div>'."\n";


if ( !defined('ACCOUNT_CLOSED') ) {

	$sql = $db->get_list_object("SELECT `id`, `tweet`, `who`, `avatar`, `via`, `datetime`, `ip` FROM `".TABLE_TWITTER."` WHERE `active` = 1 $ADD ORDER BY `xtime` DESC LIMIT $start, $kweeks_by_page");
	foreach ( $sql as $row ) {
		$row->id       = secure( $row->id, 'num');
		$row->tweet    = clickable( secure( $row->tweet, 'strip', 'clean') );
		$row->who      = secure( $row->who, 'strip', 'clean');
		$row->via      = secure( $row->via, 'strip', 'clean');
		$row->datetime = formattimestamp( secure( $row->datetime, 'strip', 'clean') );
		$row->ip       = secure( $row->ip, 'strip', 'clean');

		( defined('URL_REWRITING') ) ? $url = 'twitter-'.$row->who.'.html' : $url = URL_MODULE.'&amp;kweek='.$row->who;
		$who = '<a class="pseudo bold" href="'.$url.'" title="'._KWEEK_OF.' '.$row->who.'" >'.$row->who.'</a> '."\n";

		echo '<div class="corner hidden" '.ON_MOUSE_OVER.'>'."\n";

		echo '<table style="width:100%"><tr><td style="vertical-align:top;">'."\n";

		$url_who = '<a href="'.$url.'" title="'._KWEEK_OF.' '.$row->who.'">';

		if ( ! empty( $row->avatar ) AND is_file( FOLDER_AVATARS.''.$row->avatar ) )
			echo '<div class="img_avatar">'.$url_who.'<img src="'.FOLDER_AVATARS.''.$row->avatar.'" alt="" /></a></div>'."\n";
		else
			echo $url_who.'<img src="'.AVATAR_DEFAULT.'" alt="" /></a>'."\n";


		echo '</td><td class="content_kweek">'."\n";

		echo $who.' '.$row->tweet ;

		br( 1 );

		echo '<div class="spacer"></div><span class="date_kweek">'.$row->datetime.' '._VIA.' '.$row->via.'</span>'."\n";


		if ( defined('USER_ALLOW') or defined('ADMIN_ALLOW') ) {

			br( 2 );
			echo '<div class="gestion_by_kweek"><p>'."\n";

			if ( ALLOW_KWEEKER === true AND $row->who != $cookie[1] )
				echo ' <a class="deactive" href="'.URL_MODULE.'&amp;respons=1&amp;id='.$row->id.'&amp;who='.$row->who.'" title="'._REPLY.'">'._REPLY.'</a> '."\n";

			if ( defined('ADMIN_ALLOW') ) {
				echo ' IP: '.$row->ip.' '."\n";

				echo ' <a class="deactive" href="'.URL_MODULE.'&amp;op=status&amp;id='.$row->id.'&amp;status=0" title="'._DEACTIVE.'">'._DEACTIVE.'</a> '."\n";
			}

			if ( $row->who == $cookie[1] or defined('ADMIN_ALLOW') )
				echo ' <a class="delete" href="'.URL_MODULE.'&amp;op=delete&amp;id='.$row->id.'" title="'._DELETE.'">'._DELETE.'</a> '."\n";
			echo '</p></div>'."\n";
		}

		echo '</td></tr></table></div>'."\n";
	}

} else {

	echo '<br/><fieldset><legend>'._ACCOUNT_DEACTIVE_ALERT.' '.$kweek.'</legend><br/>'._ACCOUNT_DEACTIVE.'<br/><br/></fieldset>'."\n";
}


echo '</td><td valign="top">'."\n";

menu_lateral();

echo '</td></tr></table>'."\n";

if ( defined('USER_ALLOW') ) {
	?>
		<script type="text/javascript">
		//<![CDATA[
		document.getElementById('first').focus()
		//]]>
		</script>
	<?php
}
pagination( TOTAL_PAGES, $page_courante, KWEEKS_PAGINATION );

incof();