<?php
/************************************************************************/
/* PHP Kweeker / Minimus: Web Portal System                             */
/* ========================================                             */
/* Write by Cyril Levert                                                */
/* Copyright (c) 2009 - 2010                                            */
/* PHP Kweeker : http://twitter.php-minimus.org                         */
/* Blog and CMS : http://www.php-minimus.org                            */
/* dev@php-minimus.org                                                  */
/* Write by: Cyril Levert                                               */
/*                                                                      */
/* This program is free software.                                       */
/************************************************************************/
/* Based on PHP-Maximus: Web Portal System                              */
/************************************************************************/
defined('MINIMUS') or Header('Location: ../../index.php');
if( !defined('USER_ALLOW') ) redirect_url( URL_MODULE  );

$pagetitle = _MY_PROFIL.' - '._TWITTER_AND_FUN;
isset( $ok ) ? $ok = secure( $ok, 'bin') : $ok = '';
isset( $upload ) ? $upload = secure( $upload, 'bin') : $upload = '';
isset( $delete ) ? $delete = secure( $delete, 'bin') : $delete = '';

define('TRANSITION_JS', true);
define('INCLUDE_JS', '<script type="text/javascript" src="kernel/js/div.js"></script>');

incoh();

echo '<table><tr><td style="width:100%;vertical-align:top;" id="full_page">'."\n";

echo '<div style="color:#333;font-size:20px;margin-bottom:28px">'._MY_PROFIL.'</div>'."\n";

if ( !empty( $delete ) && defined('USER_ALLOW') ) {
	$row = $db->get_object("SELECT `id`, `uid`, `photo` FROM `".TABLE_TWITTER_ACCOUNT."` WHERE `uid` = '". secure( $cookie[0], 'num'). "' ");
	if ( $row->uid == $cookie[0] ) {
		if ( unlink ( FOLDER_AVATARS.$row->photo ) ) {
			echo '<div id="succesDiv" class="succes">'._IMAGE_DELETED.'</div>';
			$GLOBALS['db']->query("UPDATE `".TABLE_TWITTER_ACCOUNT."` SET `photo`='' WHERE `uid` = '". secure( $cookie[0], 'num'). "' ");
			op_database::optimize( TABLE_TWITTER_ACCOUNT );
			security_files();
		}
	}
}

if ( empty( $upload ) && !empty( $ok ) && defined('USER_ALLOW') ) {
	$bio  = substr( $bio, 0, BIO_LENGTH );
	$xweb = str_replace('http://', '', strtolower( $xweb ) );
	echo '<div id="succesDiv" class="succes">'._PROFIL_MODIFIED.'</div>'."\n";
	$GLOBALS['db']->query("UPDATE `".TABLE_TWITTER_ACCOUNT."` SET `nom`='".addslashes($nom)."', `local`='".addslashes($xlocal)."', `web`='".addslashes($xweb)."', `bio`='".addslashes($bio)."' WHERE `uid` = '". secure( $cookie[0], 'num'). "' ");
	op_database::optimize( TABLE_TWITTER_ACCOUNT );
}

if ( !empty( $upload ) && defined('USER_ALLOW')  ) {
	if ( empty($_FILES) ) die('File is empty');
	$dossier = FOLDER_AVATARS;
	$fichier = basename($_FILES['xphoto']['name']);
	$taille_maxi = AVATAR_WEIGHT_MAXI;
	$width_maxi = $height_maxi = AVATAR_SIZE_MAXI;
	$taille = filesize($_FILES['xphoto']['tmp_name']);
	$extensions = array('.png', '.gif', '.jpg', '.jpeg');
	$extension = strrchr($_FILES['xphoto']['name'], '.');
	if(!in_array($extension, $extensions))
		die( _UPLOAD_IMAGE_ONLY.' '.$fichier);
	if ( $taille > $taille_maxi )
		die( _UPLOAD_IMAGE_SIZE );

	list($width, $height, $type, $attr) = getimagesize($_FILES['xphoto']['tmp_name']);

	if ( $width > $width_maxi )
		die( _UPLOAD_IMAGE_SIZE );
	if ( $height > $height_maxi )
		die( _UPLOAD_IMAGE_SIZE );

	$fichier = strtr($fichier,
		'',
		'AAAAAACEEEEIIIIOOOOOUUUUYaaaaaaceeeeiiiioooooouuuuyy');
	$fichier = preg_replace('/([^.a-z0-9]+)/i', '-', $fichier);
	if(move_uploaded_file($_FILES['xphoto']['tmp_name'], $dossier . $fichier)) {
		chmod ( FOLDER_AVATARS.$fichier, 0777);
		echo '<div id="succesDiv" class="succes">'._IMAGE_MODIFIED.'</div>';
		$GLOBALS['db']->query("UPDATE `".TABLE_TWITTER_ACCOUNT."` SET `photo`='".addslashes($fichier)."' WHERE `uid` = '". secure( $cookie[0], 'num'). "' ");
		op_database::optimize( TABLE_TWITTER_ACCOUNT );
		security_files();
	} else {
		echo '<div id="errorDiv" class="error">'._UPLOAD_IMAGE_FAILED.'</div>'."\n";
	}

}

$row = $db->get_object("SELECT `id`, `nom`, `photo`, `local`, `web`, `bio` FROM `".TABLE_TWITTER_ACCOUNT."` WHERE `uid` = '". secure( $cookie[0], 'num'). "' ");

$row->id    = secure( $row->id, 'num');
$row->nom   = secure( $row->nom, 'strip', 'clean');
$row->photo = secure( $row->photo, 'strip', 'clean');
$row->local = secure( $row->local, 'strip', 'clean');
$row->web   = secure( $row->web, 'strip', 'clean');
$row->bio   = secure( $row->bio, 'strip', 'clean');

echo '<table style="width:100%">'."\n";
echo '<tr><td style="width:25%;vertical-align:top">'._PHOTO.'</td><td>'."\n";

if ( empty( $row->photo ) )
	echo '<img style="float:left;margin: 0 10px 20px 0;" src="'.AVATAR_DEFAULT.'" alt="" />'."\n";
else
	echo '<img style="float:left;margin: 0 10px 20px 0;" src="'.FOLDER_AVATARS.''.$row->photo.'" alt="" />'."\n";

echo '<a href="javascript:visibilite(\'upload\');">'._IMAGE_EDIT.'</a><br/>'."\n";
echo '<a href="'.URL_MODULE.'&amp;op=profil&amp;delete=1">'._IMAGE_DELETE.'</a><br/>'."\n";

echo '<div id="upload" style="display:none"><span style="font-size:12px;color:#808080;">'._IMAGE_SIZE_MAXI.'</span><br/>'."\n";
echo '<form action="'.URL_MODULE.'" method="post" enctype="multipart/form-data">'."\n";
echo '<input type="file" name="xphoto" size="24" />'."\n";
echo '<input type="hidden" name="op" value="profil" />'."\n";
echo '<input type="hidden" name="upload" value="1" />'."\n";
echo '<input type="hidden" name="MAX_FILE_SIZE" value="'.AVATAR_WEIGHT_MAXI.'" />'."\n";
echo '<input type="submit" value="'._UPLOAD_IT.'" />'."\n";
echo '</form></div>'."\n"."\n";

echo '</td></tr>';
echo '<tr><td style="vertical-align:top"><form action="'.URL_MODULE.'" method="post">'."\n";
echo _USERNAME.'</td><td><input tabindex="1" type="text" name="nom" value="'.$row->nom.'" />
<br/><span style="font-size:11px;color:#808080;">'._USERNAME_REAL.'</span><br/><br/></td></tr>'."\n";
echo '<tr><td style="vertical-align:top">'._LOCALISATION.'</td><td><input tabindex="2" type="text" name="xlocal" value="'.$row->local.'" /> <br/><span style="font-size:11px;color:#808080;">'._WHERE_ARE_YOU.'</span><br/><br/></td></tr>'."\n";
echo '<tr><td style="vertical-align:top">'._WEB.'</td><td><input tabindex="3" type="text" name="xweb" value="'.$row->web.'" /><br/><span style="font-size:11px;color:#808080;">'._YOUR_BLOG.'</span><br/><br/> </td></tr>'."\n";

echo "<tr><td style='vertical-align:top'>Bio</td><td><textarea tabindex='4' onkeyup=\"limite(this,'150');\" onkeydown=\"limite(this, '150');\" name='bio'>".$row->bio."</textarea>"."\n";
echo '<br/><span style="font-size:11px;color:#808080;">'._ABOUT_YOU.'</span><br/><br/>'."\n";
echo '<input type="hidden" name="ok" value="1" />'."\n";
echo '<input type="hidden" name="op" value="profil" />'."\n";
echo '<input type="submit" value="'._TAKE_IN.'" title="'._TAKE_IN.'" tabindex="5" />'."\n";
echo '</form></td></tr></table>';


echo '</td><td valign="top">'."\n";

menu_lateral();

echo '</td></tr></table>';

incof();
