<?php
/************************************************************************/
/* PHP Kweeker / Minimus: Web Portal System                             */
/* ========================================                             */
/* Write by Cyril Levert                                                */
/* Copyright (c) 2009 - 2010                                            */
/* PHP Kweeker : http://twitter.php-minimus.org                         */
/* Blog and CMS : http://www.php-minimus.org                            */
/* dev@php-minimus.org                                                  */
/* Write by: Cyril Levert                                               */
/*                                                                      */
/* This program is free software.                                       */
/************************************************************************/
/* Based on PHP-Maximus: Web Portal System                              */
/************************************************************************/
defined('MINIMUS') or Header('Location: ../../index.php');

isset( $query ) ? $query = secure( $query, '', 'clean', 'sec' ) : $query = '';
if ( empty( $query ) ) redirect_url( GET_REFERER );

isset( $id ) ? $id = secure( $id, 'num') : $id = '';
isset( $ok ) ? $ok = secure( $ok, 'bin') : $ok = '';
isset( $respons ) ? $respons = secure( $respons, 'bin') : $respons = '';

if ( strlen( $query ) < NB_LETTERS_SEARCH ) unset( $query );

$ADD = $who = '';
if ( !empty( $kweek ) ) $ADD = ' AND ( `who`="'.addslashes( $kweek ).'" OR `reponse`="'.addslashes( $kweek ).'" )';


$sql = "SELECT `tweet` FROM `".TABLE_TWITTER."` WHERE `active`= 1 AND `tweet` LIKE '%$query%' ORDER BY `xtime` DESC LIMIT 1";

if ( !$num = $db->get_num( $sql ) ) {
	define('NO_RESULT', true );
	unset( $query );
}

$last = $db->get_object( $sql );
$last->tweet = secure( $last->tweet, 'strip', 'clean');

define('LIMITE_TEXTAREA_TWITTER', TRUE);


/** Definition des attributs */
//define('NB_KWEEKS', get_number_kweeks( $kweek ) );
define('NB_KWEEKS', $num );
define('TOTAL_PAGES', ceil( NB_KWEEKS / KWEEKS_BY_PAGE ) );
if( !isset( $page ) ){
	$page_courante = 1;
} else {
	if ( $page < 1 ) {
		$page_courante = 1;
	} elseif ($page > TOTAL_PAGES ) {
		$page_courante = TOTAL_PAGES ;
	} else {
		$page_courante = $page;
	}
}
define('START', ($page_courante * KWEEKS_BY_PAGE - KWEEKS_BY_PAGE ) );

if ( empty( $kweek ) ) {
	define('PAGE_LINK', URL_MODULE );
} else {
	define('PAGE_LINK', URL_MODULE.'&amp;kweek='.$kweek );
}

define('PAGE_LINK', URL_MODULE );
define('ALERTE_SEARCH_TWITTER', true);

$pagetitle = bb_kill( $last->tweet ).' - '._TWITTER_AND_FUN;

incoh();

echo '<table><tr><td id="full_page">'."\n";


if ( !empty( $query ) ) {

	echo '<div style="color:#333;font-size:20px;margin-bottom:8px">'._YOUR_SEARCH.' '.$query.'</div>'."\n";

	! defined('KWEEKS_BY_PAGE') ? $billets_by_page = 5 : $kweeks_by_page = KWEEKS_BY_PAGE;
	! defined('START') ? $start = 0 : $start = START;
	if ( $start < 0 ) $start = 0;

	$sql = $db->get_list_object("SELECT `id`, `tweet`, `who`, `avatar`, `via`, `datetime` FROM `".TABLE_TWITTER."` WHERE `active` = 1 AND `tweet` LIKE '%$query%' ORDER BY `xtime` DESC LIMIT $start, $kweeks_by_page");
	foreach ( $sql as $row ) {
		$row->id       = secure( $row->id, 'num');
		$row->tweet    = clickable( secure( $row->tweet, 'strip', 'clean') );
		$row->who      = secure( $row->who, 'strip', 'clean');
		$row->via      = secure( $row->via, 'strip', 'clean');
		$row->datetime = formattimestamp( secure( $row->datetime, 'strip', 'clean') );


		$who = '<a class="pseudo bold" href="'.URL_MODULE.'&amp;kweek='.$row->who.'" title="'.$row->who.'" >'.$row->who.'</a> '."\n";

		echo '<div class="corner hidden" onmouseover=\'this.style.backgroundColor="#f7f7f7"\' onmouseout=\'this.style.backgroundColor="#fff"\'>'."\n";

		echo '<table style="width:100%"><tr><td style="vertical-align:top;">';


		if ( ! empty( $row->avatar ) AND is_file( FOLDER_AVATARS.''.$row->avatar ) )
			echo '<div style="width:70px"><img src="'.FOLDER_AVATARS.''.$row->avatar.'" alt="" /></div>';
		else
			echo '<img src="'.AVATAR_DEFAULT.'" alt="" />';


		echo '</td><td style="vertical-align:top;padding-left:10px;width:100%;">'."\n";

		echo $who.' '.$row->tweet.' <br/>'."\n";

		echo '<div style="margin:4px;"></div><span style="color:#999;font-size:11px;">'.$row->datetime.' '._VIA.' '.$row->via.'</span>'."\n";

		if ( defined('USER_ALLOW') or defined('ADMIN_ALLOW') ) {
			echo '<br/><br/><div style="text-align:right;font-size:11px;"><p>'."\n";

			if ( ALLOW_KWEEKER === true AND $row->who != $cookie[1] )
				echo ' <a class="deactive" href="'.URL_MODULE.'&amp;respons=1&amp;id='.$row->id.'&amp;who='.$row->who.'" title="'._REPLY.'">'._REPLY.'</a> '."\n";

			if ( defined('ADMIN_ALLOW') )
				echo ' <a class="deactive" href="'.URL_MODULE.'&amp;op=status&amp;id='.$row->id.'&amp;status=0" title="'._DEACTIVE.'">'._DEACTIVE.'</a> '."\n";

			if ( $row->who == $cookie[1] or defined('ADMIN_ALLOW') )
				echo ' <a class="delete" href="'.URL_MODULE.'&amp;op=delete&amp;id='.$row->id.'" title="'._DELETE.'">'._DELETE.'</a> '."\n";
			echo '</p></div>'."\n";
		}

		echo '</td></tr></table></div>'."\n";
	}

} else {
	if ( ! defined('NO_RESULT') ) echo '<br/><br/>'._SEARCH_ERROR ;
	if ( defined('NO_RESULT') ) echo '<br/><br/>'._SEARCH_NULL;
}
echo '</td><td valign="top">'."\n";

menu_lateral();

echo '</td></tr></table>'."\n";
?>
	<script type="text/javascript">
	document.getElementById('first').focus()
	</script>
<?php

br( 1 );
pagination( TOTAL_PAGES, $page_courante, $position=false );

incof();
