<?php
/************************************************************************/
/* Minimus Blog: Web Portal System                                      */
/* ===============================                                      */
/* Write by Cyril Levert                                                */
/* Copyright (c) 2009-2010                                              */
/* http://www.php-minimus.org                                           */
/* dev@php-minimus.org                                                  */
/*                                                                      */
/* This program is free software.                                       */
/************************************************************************/
/* Based on PHP-Maximus: Web Portal System                              */
/************************************************************************/
defined('MINIMUS') OR die ('Access denied config_users.php');
if ( ! defined('ADMIN_ALLOW') ) redirect_url(MyA_URL);

define('TRANSITION_JS', true);

isset( $activadmin  ) ? $activadmin = secure( $activadmin , 'num' ) : $activadmin = '';
isset( $activid  ) ? $activid = secure( $activid , 'num' ) : $activid = '';
isset( $create  ) ? $create = secure( $create , 'bin' ) : $create = '';
isset( $createid  ) ? $createid = secure( $createid , 'bin' ) : $createid = '';
isset( $modifid  ) ? $modifid = secure( $modifid , 'num' ) : $modifid = '';
isset( $supprimid  ) ? $supprimid = secure( $supprimid , 'num' ) : $supprimid = '';
isset( $active  ) ? $active = secure( $active , 'bin' ) : $active = '';
isset( $valid ) ? $valid = secure( $valid, 'bin') : $valid = '';
isset( $xactive  ) ? $xactive = secure( $xactive , 'bin' ) : $xactive = '';
isset( $xpseudo ) ? $xpseudo = secure( $xpseudo, '', 'clean', 'xss') : $xpseudo = '';
isset( $xemail ) ? $xemail = secure( $xemail, '', 'clean', 'xss') : $xemail = '';
isset( $xwebsite ) ? $xwebsite = secure( $xwebsite, '', 'clean', 'xss') : $xwebsite = '';
isset( $xpassword ) ? $xpassword = secure( $xpassword, '', 'clean', 'xss') : $xpassword = '';
isset( $user_id ) ? $user_id = secure( $user_id, 'num') : $user_id = '';


incoh();
Menu(5);
br(1);
if ( !empty( $supprimid ) ) {
	$db->query("DELETE FROM `".TABLE_USERS."` WHERE `user_id`='$supprimid' ");
	( !empty( $SQL ) ) ? div_succes( 'suppression du compte') : '';
	( !empty( $SQL ) ) ? op_database::optimize( TABLE_USERS ) : '';
	if ( is_module('Twitter') ) {
		$row = $db->get_object("SELECT `who` FROM `".TABLE_TWITTER."` WHERE `uid`='$did' ");
		$GLOBALS['db']->query("DELETE FROM `".TABLE_TWITTER_ACCOUNT."` WHERE `uid`='$did' ");
		op_database::optimize( TABLE_TWITTER_ACCOUNT );
		$GLOBALS['db']->query("DELETE FROM `".TABLE_TWITTER."` WHERE `who`='".$row->who."' OR `reponse`='".$row->who."' ");
		op_database::optimize( TABLE_TWITTER );
	}
}
if ( !empty( $activid ) ) {
	$SQL = $db->query("UPDATE `".TABLE_USERS."` SET `user_active`='$active' WHERE `user_id`='$activid' AND `user_id`!=1 AND `user_id`!=2 ");
	( !empty( $SQL ) ) ? div_succes( _MA_UPDATE_ACCOUNT ) : '';
	( !empty( $SQL ) ) ? op_database::optimize( TABLE_USERS ) : '';
}
if ( !empty( $activadmin ) ) {
	$SQL = $db->query("UPDATE `".TABLE_USERS."` SET `adjoint`='$active' WHERE `user_id`='$activadmin' AND `user_id`!=1 AND `user_id`!=2 ");
	( !empty( $SQL ) ) ? div_succes( _MA_UPDATE_ACCOUNT ) : '';
	( !empty( $SQL ) ) ? op_database::optimize( TABLE_USERS ) : '';
}
if ( $valid == 1 ) {
	$pass = '';
	$xwebsite = str_replace('http://', '', $xwebsite );
	if (!empty( $xpassword ) ) $pass= ", `user_password`='".sha1($xpassword)."'";
	$SQL = $db->query("UPDATE `".TABLE_USERS."` SET `username`='$xpseudo', `user_email`='$xemail', `user_website`='$xwebsite'$pass, `user_active`='$xactive' WHERE `user_id`='$user_id' AND `user_id`!=1 AND `user_id`!=2 ");
	( !empty( $SQL ) ) ? div_succes( _MA_UPDATE_ACCOUNT ) : div_error( _MA_UPDATE_ACCOUNT_NO );
	( !empty( $SQL ) ) ? op_database::optimize( TABLE_USERS ) : '';
	if ( is_module('Fluxbb') ) {
		if (!empty( $xpassword ) ) $pass = ", `password`='".sha1($xpassword)."'";
		$SQL1 = $db->query("UPDATE `".$prefix."_fluxbb_users` SET `url`='$xwebsite'$pass WHERE `email`='".$xemail."' ");
		( !empty( $SQL1 ) ) ? op_database::optimize( $prefix.'_fluxbb_users' ) : '';
	}
}
if ( $create == 1 ) {
	isset( $xpseudo ) ? $xpseudo = secure( $xpseudo, '', 'hard', 'xss') : $xpseudo = '';
	isset( $xemail ) ? $xemail = secure( $xemail, '', 'hard', 'xss') : $xemail = '';
	isset( $xpassword ) ? $xpassword = secure( $xpassword, '', 'hard', 'xss') : $xpassword = '';
	isset( $xwebsite ) ? $xwebsite = secure( $xwebsite, '', 'hard', 'xss') : $xwebsite = '';
	$xwebsite = str_replace('http://', '', $xwebsite );

	if ( empty( $xpseudo ) ) die('Alert !!! Username is empty !');
	if ( empty( $xemail ) ) die('Alert !!! Email is empty !');
	if ( empty( $xpassword ) ) die('Alert !!! Password is empty !');

	$SQL = $db->query("INSERT INTO `".TABLE_USERS."` VALUES(NULL,'$xpseudo','$xemail','".sha1($xpassword)."','$xwebsite',1,0,'".$config['language']."',now(), now() )");

	if ( is_module('Twitter') ) {
		$tmp = 'modules/Twitter/functions/tables.php';
		if ( is_file( $tmp ) ) include_once( $tmp );

		$ident = $db->get_object("SELECT `user_id` FROM `".TABLE_USERS."` WHERE `user_email` = '".$xemail. "' ");
		$ident->user_id = secure( $ident->user_id, 'num' );
		$num = $db->get_num("SELECT `id` FROM `".TABLE_TWITTER_ACCOUNT."` WHERE `uid` = '".$ident->user_id. "' ");
		$SQL1 = $db->query("INSERT INTO `".TABLE_TWITTER_ACCOUNT."` ( `id`, `uid`, `who`, `web`, `xtime`, `datetime`, `active`, `total` ) VALUES (NULL, '".$ident->user_id. "' , '".$xpseudo."', '".$xwebsite."', '".secure( time(), 'num')."', now(), 1, 0 )") or die( mysql_error() );
		( !empty( $SQL1 ) ) ? div_succes( _MA_CREATE_ACCOUNT_TWITTER_YES ) : div_error( _MA_CREATE_ACCOUNT_TWITTER_NO );
		( !empty( $SQL1 ) ) ? op_database::optimize( TABLE_TWITTER_ACCOUNT ) : '';
	}

	( !empty( $SQL ) ) ? div_succes( _MA_CREATE_ACCOUNT_YES ) : div_error( _MA_UPDATE_CREATE_NO );
	if ( !empty( $SQL ) ) {
		op_database::optimize( TABLE_USERS );
		$message = _MA_WELCOMETO." $sitename (".URL_SITE.")!\r\n\r\n";
		$message .= _MA_YOUUSEDEMAIL2." $email.\r\n\r\n";
		$message .= _MA_FOLLOWINGMEM."\r\n"._MA_UNICKNAME." $xpseudo\r\n"._MA_PASSWORD." $xpassword\r\n";
		$message = html_entity_decode( $message );
		email::send( $xemail, $adminmail, $adminmail, _MA_MAIL_NEW_ACCOUNT.' '.$sitename, $message);
	}
}


if ( !empty( $modifid ) ) {
	$tmp = 'modules/MyAccount/class/formulaires.php';
	if ( is_file( $tmp ) ) include_once( $tmp );
	$form = new Form();
	echo '<fieldset><legend>'._MA_EDIT_ACCOUNT.'</legend>';
	$sql = "SELECT * FROM `".TABLE_USERS."` WHERE `user_id` = '$modifid'";
	$info = $GLOBALS['db']->get_object( $sql );
	$form->Debut_DT(MyA_URL, 'Form field_coordonees');
	$form->Input_DT( _MA_USERNAME, 'pseudo', 'pseudo', $info->username, 1);
	$form->Input_DT( _MA_ADRESSE_EMAIL, 'email', 'email', $info->user_email, 2 );
	$form->Input_DT( _MA_WEBSITE, 'website', 'website', $info->user_website, 3 );
	$form->Input_DT( _MA_PASSWORD, 'password', 'password', '', 4 );
	$form->Radio_Edit_DT ( $info->user_active, 'active', _MA_ACTIVATION );
	$form->Input_hidden_DT('user_id', $modifid );
	$form->Fin_DT( _MA_VALIDER_PARAMETRES , 5 );
	$form->Close_DT( 'config_users' );
	echo '</fieldset><br />';
}

if ( !empty( $createid ) ) {
	$tmp = 'modules/MyAccount/class/formulaires.php';
	if ( is_file( $tmp ) ) include_once( $tmp );
	$form = new Form();
	echo '<fieldset><legend>'._MA_CREATE_ACCOUNT.'</legend>';
	$form->Debut_DT(MyA_URL, 'Form field_coordonees');
	$form->Input_DT( _MA_USERNAME, 'pseudo', 'pseudo', '', 1);
	$form->Input_DT( _MA_ADRESSE_EMAIL, 'email', 'email', '', 2 );
	$form->Input_DT( _MA_WEBSITE, 'website', 'website', '', 3 );
	$form->Input_DT( _MA_PASSWORD, 'password', 'password', '', 4 );
	$form->Fin_DT( _MA_VALIDER_PARAMETRES , 5 );
	$form->Close_DT_Create( 'config_users' );
	echo '</fieldset><br />';
}

echo '<fieldset><legend>'._MA_USERS_GESTION.' &raquo; <a href="'.MyA_URL.'&amp;op=config_users&amp;createid=1">'._MA_CREATE_USER.'</a></legend>';
echo '<table width="100%"><tr class="tableau_titre"><td>id</td><td>'._MA_USERNAME.'</td><td>'._MA_ADRESSE_EMAIL.'</td><td>'._MA_WEBSITE.'</td><td width="80">'._MA_ACTIF.'</td><td width="80">'._MA_ADMIN.'</td><td width="130">'._MA_FUNCTIONS.'</td></tr>';
$sql = "SELECT * FROM `".TABLE_USERS."` ORDER BY `user_id` DESC ";
foreach( $GLOBALS['db']->get_list_object( $sql ) as $sess ) {
	echo '<tr class="tableau_content"><td>'.$sess->user_id.'</td><td>'.$sess->username.'</td><td> '.$sess->user_email.'</td><td> '.$sess->user_website.'</td><td>';
	$sel = $sel1 = '';
	echo '<form action="" method="post">';
	$url= MyA_URL.'&amp;op=config_users&amp;activid='.$sess->user_id.'&amp;active=';
	echo '<select name="userid" onchange="top.location.href=this.options[this.selectedIndex].value">';
	if ( empty( $sess->user_active ) ) $sel = ' selected="selected"';
	echo '<option value='.$url.'1 '.$sel.'>'._YES.'</option>';
	echo '<option value='.$url.'0 '.$sel.'>'._NO.'</option>';
	echo '</select></form></td>';

	$sel = $sel1 = '';
	echo '<td><form action="" method="post">';
	$url= MyA_URL.'&amp;op=config_users&amp;activadmin='.$sess->user_id.'&amp;active=';
	echo '<select name="userid" onchange="top.location.href=this.options[this.selectedIndex].value">';
	if ( empty( $sess->adjoint ) ) $sel = ' selected="selected"';
	echo '<option value='.$url.'1 '.$sel.'>'._YES.'</option>';
	echo '<option value='.$url.'0 '.$sel.'>'._NO.'</option>';
	echo '</select></form>';

	echo '</td><td><a href="'.MyA_URL.'&amp;op=config_users&amp;modifid='.$sess->user_id.'">'._EDIT.'</a> <a onclick=\'return window.confirm("'. _MA_SURE_DELETE_ACCOUNT. '");\' href="'.MyA_URL.'&amp;op=config_users&amp;supprimid='.$sess->user_id.'">'._DELETE.'</a>';
	echo '</td></tr>';
}
echo '</table>';

echo '</fieldset>';

incof();